/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

^
RlƂ̐liEuler, Heun, RungeKutta)̔r
^C}[gp
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../rigid3D.h"
#include "../../setup.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();
void initObject();
void timer(int value);
void initStrict();
void initEuler();
void initRunge();
void strict();
void euler(float dt);
void runge(float dt);

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2;
//VF[_vO
GLuint shaderProg;

CVector pos0;//Ŏgp鏉ʒu
CVector vel0;//Ŏgp鏉x
CVector size0;
enum SimulationMode { S_STRICT, S_EULER, S_RUNGE};
SimulationMode simulationMode = S_STRICT;
int massIndex = 2;
float mass0 = 0.01;//KgP
int stepIndex = 1;
float timeStep = 5;//msP

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_TestProjectile1");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
	//^C}[
	glutTimerFunc(1, timer, 0);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");
	
  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 50.0;
	view.vCnt = CVector(0.0, 0.0, 8.0);
	view.theta = 0.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //init()̑oߎ

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
  setTexture();
  
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	createDisplayListsPet();
	createDisplayListsVehicle();
	initObject();

	//L[̐
	printf("L[ɂÎ̕sړ(t)E](r)Eʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[i]key:]̍W(/޼ުĎj̕ύX \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[a]key:e\/\؂ւ \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[T]key:gbN[h؂ւ \n");
	printf("[S]key:Xg{\/\؂ւ \n");
	printf("[F]key:tA\/\؂ւ \n");
	printf("[F1]key:^CXebv̑ \n");
	printf("[F2]key:ʂ̑ \n");

}

void initObject()
{
	flagStrobo = true;
	countStrobo = 0;
	timeStrobo = 0.0;
	periodStrobo = 0.1;
	flagStart = false;

	viscous = 0.00017;//a0.5m̋(x20Cɑ΂SRW)

	maxStrobo = 40;//P񓖂Xg{
	//̂̏ݒ
	numRigid = 3 * maxStrobo;//+2;

	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	rigid[0].mass = mass0;
	rigid[0].vSize = size0 = CVector(0.74, 0.74, 0.74);
	rigid[0].vPos = pos0 = CVector(0.0, -15.0, 0.5);
	rigid[0].vVelocity = vel0 = CVector(0.0, 8.0, 18.0);

	simulationMode = S_STRICT;
	initStrict();
}

void initStrict()
{
	selNo = 0;
	for(int i = 1; i < numRigid; i++) {
		rigid[i].color = WHITE;
		rigid[i].vSize = CVector(0.5, 0.5, 0.5);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}
	rigid[1].vPos = rigid[0].vPos;
	//rigid[0].mass = 0.145;//d싅{[//0.001;
}

void initEuler()	
{
	selNo = maxStrobo;

	rigid[selNo].mass = mass0;
	rigid[selNo].vSize = size0;
	rigid[selNo].vPos = pos0;
	rigid[selNo].vVelocity = vel0;

	for(int i = selNo+1; i < selNo + maxStrobo; i++) {
		rigid[i].color = CYAN;
		rigid[i].vSize = CVector(0.5, 0.5, 0.5);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}
	//strobȍʒu
	rigid[selNo + 1].vPos = rigid[selNo].vPos;
}
void initRunge()	
{
	selNo = 2 * maxStrobo;

	rigid[selNo].mass = mass0;
	rigid[selNo].vSize = size0;
	rigid[selNo].vPos = pos0;
	rigid[selNo].vVelocity = vel0;

	for(int i = selNo+1; i < selNo + maxStrobo; i++) {
		rigid[i].color = YELLOW;
		rigid[i].vSize = CVector(0.5, 0.5, 0.5);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}
	//strobȍʒu
	rigid[selNo + 1].vPos = rigid[selNo].vPos;
//printf("px=%f, py=%f, pz=%f \n", rigid[selNo].vPos.x, rigid[selNo].vPos.y, rigid[selNo].vPos.z);
//printf("vx=%f, vy=%f, vz=%f \n", rigid[selNo].vVelocity.x, rigid[selNo].vVelocity.y, rigid[selNo].vVelocity.z);
}

void setTexture()
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void timer(int value)
{
	glutPostRedisplay();//timeStepԊudisplays
	glutTimerFunc((int)timeStep, timer, 0);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	for(int i = 0; i < numRigid; i++)
	{
		if(i == selNo)
		{
			glUniform1i(selLoc, 1);
			rigid[i].select = true;
		}
		else
		{
			glUniform1i(selLoc, 0);
			rigid[i].select = false;
		}
		if(flagStrobo) rigid[i].draw(false);
		else rigid[selNo].draw(false);
	}

  glUseProgram(0);

	if(flagStart == true && flagFreeze == false) 
	{
	  //rigid[0].action3D(speedRate * dt);
		if(simulationMode == S_STRICT) strict();
		else if(simulationMode == S_EULER) euler(dt); 
		else if(simulationMode == S_RUNGE) runge(dt);

		if(flagOneStep) flagFreeze = true;
		
		if(countStrobo < maxStrobo)
		{
			if( timeStrobo == 0.0) rigid[selNo + 1 + countStrobo].vPos = rigid[selNo].vPos;

			timeStrobo += dt;
//printf("count=%d  t=%f\n", countStrobo, timeStrobo);
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
		}
	}

	if(flagFloor) glCallList(floor0);//En
  if(flagShadow) drawShadow();     //e
	if(flagCoord) 
	{
		drawWorldCoordinates(2.0); //[hԂ̍W
//	  drawInertialCoordinates(rigid[0], 2.0); //Ԃ̍W
//	  drawObjectCoordinates(rigid[0], 2.0);   //IuWFNgԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("frame rate=%d[fps]", fps0, 10, 30);
		drawParam("timeStep=%3.1f", timeStep, 220, 30);
		drawParam("mass0=%3.3f", mass0, 400, 30);
	}

	if(flagTrack)//ɃR[fBOƕ\Ȃ
	{
		view.vCnt.x = rigid[selNo].vPos.x;
		view.vCnt.y = rigid[selNo].vPos.y;
		setCamera();
	}

//glFlush();
	//obt@̐؂ւ
 glutSwapBuffers();
}

void strict()
{
	float b = viscous / mass0;
	CVector vA = CVector(0.0, 0.0, -g);

	rigid[0].vPos = pos0 + (1.0/b) * (vA * elapseTime2 + (vel0 - vA/b) * (1.0 - exp(-b * elapseTime2)));
	if(rigid[0].vPos.z < -2.0 || countStrobo >= maxStrobo) 
	{ 
		flagStart = false; 
		countStrobo = 0; 
		simulationMode = S_EULER;
		initEuler();
		flagStart = true;
	}
}

void euler(float dt)
{
	float b = viscous / mass0;
	CVector vAcc = CVector(0.0, 0.0, -g) - b * rigid[selNo].vVelocity;
	rigid[selNo].vVelocity += vAcc * dt;
	rigid[selNo].vPos += rigid[selNo].vVelocity * dt;
	
	if(rigid[selNo].vPos.z < -2.0 || countStrobo >= maxStrobo) 
	{ 
		flagStart = false; 
		countStrobo = 0; 
		simulationMode = S_RUNGE;
		initRunge();
		flagStart = true;
	}
}

void runge(float dt)
{
	float b = viscous / mass0;
	CVector vAcc = CVector(0.0, 0.0, -g) - b * rigid[selNo].vVelocity;
	CVector k1, k2, k3, k4;
	k1 = vAcc * dt;
	k2 = (CVector(0.0, 0.0, -g) - b * (rigid[selNo].vVelocity + k1 / 2.0)) * dt;
	k3 = (CVector(0.0, 0.0, -g) - b * (rigid[selNo].vVelocity + k2 / 2.0)) * dt;
	k4 = (CVector(0.0, 0.0, -g) - b * (rigid[selNo].vVelocity + k3)) * dt;
	rigid[selNo].vVelocity += (k1 + 2.0*k2 + 2*k3 + k4) / 6.0;
	rigid[selNo].vPos += rigid[selNo].vVelocity * dt;
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
		for(int i = 0; i < 3; i++)lightPos[i] = lightPos0[i];
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
			//if(simulationMode == S_STRICT) initStrict();
			//else initEuler();
		
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 't':
		shiftMode = TRANSLATE;
		break;
	case 'r':
		shiftMode = ROTATION;
		break;
	case 'l':
		shiftMode = LIGHT;
		break;
	case 'i':
		if(coordMode == INERTIAL) coordMode = OBJECT;
		else coordMode = INERTIAL;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'a':
		flagShadow = !flagShadow;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'T':
		flagTrack = !flagTrack;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(shiftMode == TRANSLATE)
	{
		//Î̕sړ
		float d = 0.1;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			rigid[selNo].vPos.y += d;
			break;
		case GLUT_KEY_LEFT://-y
			rigid[selNo].vPos.y -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) rigid[selNo].vPos.x -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) rigid[selNo].vPos.z += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) rigid[selNo].vPos.x += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) rigid[selNo].vPos.z -= d;//-z
			break;
		default:
			break;
		}
	}

	else if(shiftMode == ROTATION && coordMode == INERTIAL)
	{
		//Î̊Ԃɂ]
		float theta = 5.0;//[deg];

		switch( key )
		{
		case GLUT_KEY_RIGHT://y]
			rigid[selNo].q = getQFromAxis(theta, CVector(0.0, 1.0, 0.0)) * rigid[selNo].q;
			break;
		case GLUT_KEY_LEFT://-y]
			rigid[selNo].q = getQFromAxis(theta, CVector(0.0, -1.0, 0.0)) * rigid[selNo].q;
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) //-x]
				rigid[selNo].q = getQFromAxis(theta, CVector(-1.0, 0.0, 0.0)) * rigid[selNo].q;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) //z]
				rigid[selNo].q = getQFromAxis(theta, CVector(0.0, 0.0, 1.0)) * rigid[selNo].q;
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0)//x]
				rigid[selNo].q = getQFromAxis(theta, CVector(1.0, 0.0, 0.0)) * rigid[selNo].q;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)//-z]
				rigid[selNo].q = getQFromAxis(theta, CVector(0.0, 0.0, -1.0)) * rigid[selNo].q;
			break;
		default:
			break;
		}
	}

	else if(shiftMode == ROTATION && coordMode == OBJECT)
	{
		//Î̃IuWFNgԂɂ]
		float theta = 5.0;//[deg];
		switch( key )
		{
		case GLUT_KEY_RIGHT://y]
			rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, 1.0, 0.0)) ;
			break;
		case GLUT_KEY_LEFT://-y]
			rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, -1.0, 0.0));
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) //-x]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(-1.0, 0.0, 0.0));
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) //z]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, 0.0, 1.0));
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0)//x]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(1.0, 0.0, 0.0));
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)//-z]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, 0.0, -1.0));
			break;
		default:
			break;
		}
	}

	else if(shiftMode == LIGHT)
	{
		//Î̕sړ
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			lightPos[1] += d;
			break;
		case GLUT_KEY_LEFT://-y
			lightPos[1] -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) lightPos[0] -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) lightPos[0] += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//-z
			break;
		default:
			break;
		}
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) stepIndex += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) stepIndex -= 1;
		if(stepIndex > 4) stepIndex = 4;
		if(stepIndex < 0.0) stepIndex = 1;
		if(stepIndex == 0) timeStep = 1.0;
		else if(stepIndex == 1) timeStep = 5.0;
		else if(stepIndex == 2) timeStep = 10.0;
		else if(stepIndex == 3) timeStep = 50.0;
		else if(stepIndex == 4) timeStep = 100.0;
		initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) massIndex += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) massIndex -= 1;
		if(massIndex > 6) massIndex = 6;
		if(massIndex < 0) massIndex = 0;
		if(massIndex == 0) mass0 = 0.001;
		else if(massIndex == 1) mass0 = 0.005;
		else if(massIndex == 2) mass0 = 0.01;
		else if(massIndex == 3) mass0 = 0.05;
		else if(massIndex == 4) mass0 = 0.1;
		else if(massIndex == 5) mass0 = 0.5;
		else if(massIndex == 6) mass0 = 1.0;
		initObject();
	}
}

