/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

Ԃ̃Aj[V(Test)
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../rigid3D.h"
#include "../../setup.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void initObject();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2;
//VF[_vO
GLuint shaderProg;

float damping0 = 0.5;//]W

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_TestVehicle");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");
	
  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
	deleteDisplayListsVehicle();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.3, 0.3, 0.4, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 120.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 70.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //init()̑oߎ

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	createDisplayListsVehicle();
	initObject();

	//L[̐
	printf("L[ɂ鑀ǊpEݒ葬x̕ύX \n");
	printf("@,FǊpiE܁E܁j̕ύX \n");
	printf("@,FǊpOɂCOiEi̐ݒ葬xύX \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[d]key:CRL^̐؂ւ \n");
	printf("[i]key:]̍W(/޼ުĎj̕ύX \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[a]key:e\/\؂ւ \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[T]key:gbN[h؂ւ \n");
	printf("[S]key:Xg{\/\؂ւ \n");
	printf("[F]key:tA\/\؂ւ \n");
	printf("[b]key:u[L ON/OFF \n");
	printf("[F1]key:CW̑ \n");
	printf("[F2]key:ÖCW̑ \n");
}

void initObject()
{
	flagStart = false;
	flagSlide = false;
	flagStrobo = false;
	countStrobo = 0;
	timeStrobo = 0.0;
	periodStrobo = 0.2;
	timeRate = 2.0;
	restValue = 0.0;// 0.5;
	dampRotation = damping0;//ʏz]W
	vehicle.wheelRotAngle = 0.0;
	vehicle.speed0 = 5.0;//27.8;//ݒ葬x[m/s]
	vehicle.flagBrake = false;

	//̂̏ݒ
	numRigid0 = 1;
	numStrobo = 100;
	numRigid = numRigid0 + numStrobo;//100̓Xg{p
	selNo = 0;
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	rigid[0].kind = VEHICLE;// 
	rigid[0].mass = 5000.0;
	rigid[0].vPos = CVector(30.0, 0.0, vehicle.height/2.0);
	rigid[0].vVelocity = CVector(0.0, 00.0, 0.0);
	rigid[0].vForward = CVector(-1.0, 0.0, 0.0);
	vehicle.steerAngle = 0.0;
	rigid[0].vEuler = CVector(0.0, 0.0, 90.0);//Ԃ̐
	rigid[0].q = getQFromEulerXYZ(rigid[0].vEuler) * rigid[0].q;
	rigid[0].vEuler = CVector(0.0, 0.0, 90.0);//x90xȏ]ƕsm
	rigid[0].q = getQFromEulerXYZ(rigid[0].vEuler) * rigid[0].q;

	rigid[0].ready();

	for(i = numRigid0; i < numRigid; i++) {
		rigid[i].color = CYAN;
		rigid[i].vSize = CVector(1.0, 1.0, 1.0);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
			
	rigid[0].select = false;//true;
	glUniform1i(selLoc, 0);
	rigid[0].draw(false);
	if(flagStrobo) 
	{
		for(int i = numRigid0; i < numRigid; i++) 
		{
			glUniform1i(selLoc, 0);

			rigid[i].draw(false);
		}
	}

  glUseProgram(0);

	if(flagStart == true && flagFreeze == false) 
	{

		vehicle.speed = rigid[0].vVelocity.magnitudeXY();
				
		if(vehicle.speed0 >= 0.0 && !vehicle.flagBrake) //forward
		{
			if(!vehicle.flagBrake) vehicle.wheelRotAngle += (vehicle.speed / vehicle.radius) * dt * timeRate * qq;//ԗւ̐]p
			rigid[0].vForward.rotZ(vehicle.steerAngle * dt * timeRate);
			rigid[0].vVelocity.rotZ(vehicle.steerAngle * dt * timeRate);
			rigid[0].q = getQFromAxis(vehicle.steerAngle * dt * timeRate, CVector(0.0, 0.0, 1.0)) * rigid[0].q;
		}
		if(vehicle.speed0 < 0.0 && !vehicle.flagBrake)//backward 
		{
			if(!vehicle.flagBrake) vehicle.wheelRotAngle -= (vehicle.speed / vehicle.radius) * dt * timeRate * qq;//ԗւ̐]p
			rigid[0].vForward.rotZ(-vehicle.steerAngle * dt * timeRate);
			rigid[0].vVelocity.rotZ(-vehicle.steerAngle * dt * timeRate);
			rigid[0].q = getQFromAxis(-vehicle.steerAngle * dt * timeRate, CVector(0.0, 0.0, 1.0)) * rigid[0].q;
		}

		float speedDif = fabs(vehicle.speed0) - vehicle.speed;

		if(!vehicle.flagBrake)
		{
			if(vehicle.speed0 == 0.0) vehicle.flagBrake = true;
			else if(vehicle.speed0 > 0.0) 
				rigid[0].vForce0 = vehicle.accelRate * (rigid[0].mass * speedDif / (dt * timeRate)) * rigid[0].vForward;
			else rigid[0].vForce0 = - vehicle.accelRate * (rigid[0].mass * speedDif / (dt * timeRate)) * rigid[0].vForward;
		}

	  rigid[0].action2D(timeRate * dt);
		if(flagOneStep) flagFreeze = true;
	
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				rigid[1+countStrobo].vPos = rigid[0].vPos;//n
			}

			timeStrobo += dt;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = numStrobo;
		}
	}

	if(flagFloor) glCallList(floor0);//En
  if(flagShadow) drawShadow();     //e
	if(flagCoord) 
	{
		drawWorldCoordinates(2.0);              //[hԂ̍W
	  drawInertialCoordinates(rigid[0], 2.0); //Ԃ̍W
	  drawObjectCoordinates(rigid[0], 2.0);   //IuWFNgԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("muK=%3.2f", muK, 190, 30);
		drawParam("muS=%3.2f", muS, 320, 30);
		drawParam("speed0=%3.1f", vehicle.speed0, 190, 60);
		drawParam("speed = %3.3f[m/s]", rigid[0].vVelocity.magnitudeXY(), 320, 60);
	}

	if(flagTrack)
	{
		view.vCnt.x = rigid[selNo].vPos.x;
		view.vCnt.y = rigid[selNo].vPos.y;
		setCamera();
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
		for(int i = 0; i < 3; i++)lightPos[i] = lightPos0[i];
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'd':
		flagDrag = !flagDrag;
		if(flagDrag) printf("flagDrag = true \n");
		else printf("flagDrag = false\n");
		break; 
	case 't':
		shiftMode = TRANSLATE;
		break;
	case 'r':
		shiftMode = ROTATION;
		break;
	case 'l':
		shiftMode = LIGHT;
		break;
	case 'i':
		if(coordMode == INERTIAL) coordMode = OBJECT;
		else coordMode = INERTIAL;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'a':
		flagShadow = !flagShadow;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'T':
		flagTrack = !flagTrack;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;
	case 'b':
		vehicle.flagBrake = true;//!vehicle.flagBrake;
		vehicle.speed0 = 0.0;
		break; 

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
		//Ǌp
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			vehicle.steerAngle -= d;
			break;
		case GLUT_KEY_LEFT://-y
			vehicle.steerAngle += d;
			break;
		case GLUT_KEY_UP:
			vehicle.flagBrake = false;
			vehicle.steerAngle = 0.0;
			vehicle.speed0 += 1.0;
			if(vehicle.speed0 > vehicle.maxSpeed) vehicle.speed0 = vehicle.maxSpeed;
			break;
		case GLUT_KEY_DOWN:
			vehicle.flagBrake = false;
			vehicle.steerAngle = 0.0;
			vehicle.speed0 -= 1.0;
			if(vehicle.speed0 < -vehicle.maxSpeed) vehicle.speed0 = -vehicle.maxSpeed;
			break;
		default:
			break;
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) muK += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) muK -= 0.05;
		if(muK > 1.0) muK = 1.0;
		if(muK < 0.0) muK = 0.0;
		initObject();
	}

	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) muS += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) muS -= 0.1;
		if(muS < 0.0)  muS = 0.0;
		initObject();
	}

}

