/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

3D many body animation
̗eƉ~e̊Ԃŗqւ
Wlrɂ\𗘗p
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../parametersVessel.h"
#include "rigid.h"
#include "collision.h"
#include "../../setupVessel.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void mouse(int button, int state, int x, int y);
void special(int key, int x, int y);
void motion(int x, int y);
void initObject();
//void drawSprite();
void drawVessel();

//摜f[^̃TCY
int imgWidth, imgHeight;
//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;

//VF[_vO
GLuint shaderProg;
double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_Vessel2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
	//glDeleteLists(cube0, 1);

  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();

}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 150.0;
	view.vCnt = CVector(0.0, 0.0, 20.0);
	view.theta = 30.0;
	view.phi = 0.0;
	view.nearZ = 10.0;
	view.farZ = 2000.0;
	setCamera();
	view0 = view;
	//q
	numRigid = 500;
	//Փˊ֌W̏l
	e = 0.1;
	cSpring = 150.0;
	muK = 0.5;
	timeRate = 1.0;//X[[VW
	spaceCoord = 2.0;
	shiftMode = TRANSLATE;
	coordMode = INERTIAL;
  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //start̑oߎ

  setFontBitmaps();

	//display list쐬
	createDisplayLists();

	initObject();

	//L[̐
	printf("L[ɂe̕sړ(t)E](r)^ʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("e̓~߂ \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[z]key:Ie̕ύX \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[a]key:e\/\؂ւ \n");
	printf("[p]key:Ұ\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[C]key:e̊W̊J؂ւ \n");
	printf("[F]key:tA\/\؂ւ \n");
	printf("[F1]key:̐̑ \n");
	printf("[F2]key:W̑ \n");
	printf("[F3]key:CW̑ \n");
	printf("[F4]key:ol萔̑ \n");
	printf("[F5]key:x̑ \n");
}

void initObject()
{
	//^e쐬
	vesselB.widthX = 20.0;
	vesselB.widthY = 20.0;
	vesselB.widthZ = 25.0;
	vesselB.vPos = CVector(0.0, -10.0, vesselB.widthZ / 2.0 + 35.0);
	vesselB.accelMax = 5.0;
	vesselB.flagCover = true;//false;
	//vesselB.flagClose = true;
	vesselB.numSide = 6;
	vesselB.flagSelect = true;
	vesselB.ready();
	//~^e
	vesselC.radius = 15.0;
	vesselC.height = 20.0;
	vesselC.vPos = CVector(0.0, 10.0, vesselC.height/2.0 + 5.0);
	vesselC.vAlpha.z = 0.0;
	vesselC.vOmega = CVector();
	vesselC.q = CQuaternion();
	vesselC.flagCover = true;//false;
	vesselC.flagSelect = false;
	vesselC.ready();

	//̂̏ݒ
	int i;
	for(i = 0; i < numRigid; i++) 
	{//Ԃł͗q͑SĔ^e

		rigid[i].vSize = CVector(spaceCoord, spaceCoord, spaceCoord);//TCY͌Œ

		rigid[i].vPos.x = getRandom(-vesselB.widthX/2+2.0, vesselB.widthX/2.0-2.0);
		rigid[i].vPos.y = getRandom(-vesselB.widthY/2+2.0, vesselB.widthY/2.0-2.0);
		rigid[i].vPos.z = getRandom(-vesselB.widthZ/2.0+2.0, vesselB.widthZ/2.0-2.0);
		rigid[i].vPos += vesselB.vPos;
		rigid[i].vVelocity = CVector(getRandom(-1.0, 1.0), getRandom(-1.0, 1.0), 0.0);
		if(i < numRigid / 2)
		{
			rigid[i].color = CYAN;
		}
		else
		{
			rigid[i].color = YELLOW;
		}
	}

	flagStart = false;
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);

	//̂Ƃ
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	//rigid
	for(int i = vesselB.numSide; i < numRigid; i++) rigid[i].draw(false); 
	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) {//e
		drawShadow();     
		vesselB.drawShadow(view.vPos);
		vesselC.drawShadow(view.vPos);
	}

	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//vessel
	//ɕ`
	if(vDist(vesselB.vPos, view.vPos) > vDist(vesselC.vPos, view.vPos))
	{
		vesselB.draw(view.vPos, false); vesselC.draw(view.vPos, false);
	}
	else
	{
		vesselC.draw(view.vPos, false); vesselB.draw(view.vPos, false);
	}

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);

	glUseProgram(0);

	if(flagCoord) drawWorldCoordinates(20.0);

	timeStep = timeRate * dt;

	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ
	
	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
	  vesselB.vVelocity += vesselB.vAccel * timeStep;
		vesselB.vPos += vesselB.vVelocity * timeStep;
	  collision(timeStep);//Փ˔(collision.h)
		if(vesselB.flagStop)
		{
			if(vesselB.vVelocity.magnitude() < 0.5) 
			{
				vesselB.vVelocity = CVector();
				vesselB.vAccel = CVector();
				vesselB.accel = 0.0;
				vesselB.flagStop = false;
			}
			else
			{
				if(vesselB.mode == 1) 
				{
					if(     vesselB.vVelocity.x < 0.0) vesselB.accel += 0.1 * vesselB.accelMax;
					else if(vesselB.vVelocity.x > 0.0) vesselB.accel -= 0.1 * vesselB.accelMax;
					vesselB.vAccel = CVector(vesselB.accel, 0.0, 0.0);
				}
				else if(vesselB.mode == 2) 
				{
					if(    vesselB.vVelocity.y < 0.0) vesselB.accel += 0.1 * vesselB.accelMax;
					else if(vesselB.vVelocity.y > 0.0) vesselB.accel -= 0.1 * vesselB.accelMax;
					vesselB.vAccel = CVector(0.0, vesselB.accel, 0.0);
				}
				else if(vesselB.mode == 3) 
				{
					if(			vesselB.vVelocity.z < 0.0) vesselB.accel += 0.1 * vesselB.accelMax;
					else if(vesselB.vVelocity.z > 0.0) vesselB.accel -= 0.1 * vesselB.accelMax;
					vesselB.vAccel = CVector(0.0, 0.0, vesselB.accel);
				}
					
				//vesselB.vVelocity += vesselB.vAccel * timeStep; 
			}
		}
	}

	if(flagParamShow) 
	{
		drawParam("frame rate=%d[fps]", fps0, 10, 30);
		drawParam("num=%d", numRigid, 190, 30);
		drawParam("e=%3.2f", e, 290, 30);
		drawParam("muK=%3.2f", muK, 370, 30);
		drawParam("cSpring=%3.2f", cSpring, 470, 30);
		drawParam("trans=%3.2f", vesselB.trans, 10, 60);
	}

	//I
  glutSwapBuffers();
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(flagStart) elapseTime2 = 0.0;
		else initObject();
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		break;
		case 't':
		shiftMode = TRANSLATE;
		break;
	case 'r':
		shiftMode = ROTATION;
		break;
	case 'l':
		shiftMode = LIGHT;
		break;

	case 'z':
		vesselB.flagSelect = !vesselB.flagSelect;
		vesselC.flagSelect = !vesselC.flagSelect;
		break;

  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'a':
		flagShadow = !flagShadow;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'C':
		vesselB.flagCover = !vesselB.flagCover;
		if(vesselB.flagCover) vesselB.numSide = 6;
		else vesselB.numSide = 5;
		vesselC.flagCover = !vesselC.flagCover;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(shiftMode == TRANSLATE)
	{
		//̗e(vessel)̕sړ
		float d = 0.2;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			{
				if(vesselB.flagSelect) vesselB.vPos.y += d;
				else									 vesselC.vPos.y += d;
			}
			break;
		case GLUT_KEY_LEFT://-y
			{
				if(vesselB.flagSelect) vesselB.vPos.y -= d;//
				else									 vesselC.vPos.y -= d;
			}
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) 
			{
				if(vesselB.flagSelect) vesselB.vPos.x -= d;//-x
				else									 vesselC.vPos.x -= d;
			}
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)
			{
				if(vesselB.flagSelect) vesselB.vPos.z += d;//z
				else									 vesselC.vPos.z += d;
			}
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0)
			{
				if(vesselB.flagSelect) vesselB.vPos.x += d;//x
				else									 vesselC.vPos.x += d;
			}
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) 
			{
				if(vesselB.flagSelect) vesselB.vPos.z -= d;//-z
				else									 vesselC.vPos.z -= d;
			}
			break;
		default:
			break;
		}
	}

	else if(shiftMode == ROTATION && coordMode == INERTIAL)
	{
		//Î̊Ԃɂ]
		float theta = 1.0;//[deg];

		switch( key )
		{
		case GLUT_KEY_RIGHT://y]
			if(vesselB.flagSelect) vesselB.q = getQFromAxis(theta, CVector(0.0, 1.0, 0.0)) * vesselB.q;
			else vesselC.q = getQFromAxis(theta, CVector(0.0, 1.0, 0.0)) * vesselC.q;
			break;
		case GLUT_KEY_LEFT://-y]
			if(vesselB.flagSelect) vesselB.q = getQFromAxis(theta, CVector(0.0, -1.0, 0.0)) * vesselB.q;
			else vesselC.q = getQFromAxis(theta, CVector(0.0, -1.0, 0.0)) * vesselC.q;
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) //-x]
				if(vesselB.flagSelect) vesselB.q = getQFromAxis(theta, CVector(-1.0, 0.0, 0.0)) * vesselB.q;
				else vesselC.q = getQFromAxis(theta, CVector(-1.0, 0.0, 0.0)) * vesselC.q;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) //z]
				if(vesselB.flagSelect) vesselB.q = getQFromAxis(theta, CVector(0.0, 0.0, 1.0)) * vesselB.q;
				else vesselC.q = getQFromAxis(theta, CVector(0.0, 0.0, 1.0)) * vesselC.q;
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0)//x]
				if(vesselB.flagSelect) vesselB.q = getQFromAxis(theta, CVector(1.0, 0.0, 0.0)) * vesselB.q;
				else vesselC.q = getQFromAxis(theta, CVector(1.0, 0.0, 0.0)) * vesselC.q;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)//-z]
				if(vesselB.flagSelect) vesselB.q = getQFromAxis(theta, CVector(0.0, 0.0, -1.0)) * vesselB.q;
				else vesselC.q = getQFromAxis(theta, CVector(0.0, 0.0, -1.0)) * vesselC.q;
			break;
		default:
			break;
		}
	}
	if(shiftMode == LIGHT)
	{
		//Î̕sړ
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			lightPos[1] += d;
			break;
		case GLUT_KEY_LEFT://-y
			lightPos[1] -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) lightPos[0] -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) lightPos[0] += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//-z
			break;
		default:
			break;
		}
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) numRigid += 100;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) numRigid -= 100;
		if(numRigid < 100) numRigid = 100;
		if(numRigid > 1000) numRigid = 1000;
		initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) e += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) e -= 0.05;
		if(e > 1.0) e = 1.0;
		if(e < 0.0) e = 0.0;
	}

	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) muK += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) muK -= 0.05;
		if(muK > 1.0) muK = 1.0;
		if(muK < 0.0) muK = 0.0;
	}

	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) cSpring += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) cSpring -= 10.0;
		if(cSpring < 0.0) cSpring = 0.0;
	}
	if(key == GLUT_KEY_F5) 
	{
		if(glutGetModifiers() == 0) vesselB.trans += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) vesselB.trans -= 0.1;
		if(vesselB.trans < 0.0) vesselB.trans = 0.0;
		if(vesselB.trans > 1.0) vesselB.trans = 1.0;
	}
}

