/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

[znAj[V
z_ɌŒ肵Cefɂ1̖ŃV~[g
qɂ1̖Ƃ
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN_0 "../../bmp/sun2.bmp"
#define FILENAME_IN_1 "../../bmp/mercury1.bmp"
#define FILENAME_IN_2 "../../bmp/venus1.bmp"
#define FILENAME_IN_3 "../../bmp/earth1.bmp"
#define FILENAME_IN_4 "../../bmp/mars1.bmp"
#define FILENAME_IN_5 "../../bmp/jupiter1.bmp"
#define FILENAME_IN_6 "../../bmp/saturn1.bmp"
#define FILENAME_IN_7 "../../bmp/uranus1.bmp"
#define FILENAME_IN_8 "../../bmp/neptune1.bmp"
#define FILENAME_IN_9 "../../bmp/saturn2.bmp"
#define FILENAME_IN_10 "../../bmp/moon1.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../rigidSolar.h"
#include "../../setupSolar.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture(int n);
void initObject();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLuint texName[11];

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

double timeStep, timeStep0, timeStep1;

int main(int argc, char(** argv))
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_SolarSystem");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);

  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shadingS.frag");
	
  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 280.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 80.0;
	view.phi = 0.0;
	view0 = view;
	setCamera();

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ
	elapseTime3 = 0.0;//ȉ~O̎p

	//eNX`[
  glGenTextures(11, texName);//eNX`IuWFNg̖Ot
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_0);
  setTexture(0);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_1);
  setTexture(1);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_2);
  setTexture(2);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_3);
  setTexture(3);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_4);
  setTexture(4);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_5);
  setTexture(5);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_6);
  setTexture(6);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_7);
  setTexture(7);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_8);
  setTexture(8);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_9);
  setTexture(9);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_10);
  setTexture(10);
 
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[z]key:Iԍ̕ύX \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[S]key:Xg{\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
}

void initObject()
{
	flagStart = false;
	//Xg{
	flagStrobo = false;
	countStrobo = 0;
	timeStrobo = 0.0;   //oߎ
	periodStrobo = 0.05;//\Ԋu
	//^CXebv{
	timeRate = 1.0;

	//̂̏ݒ
	numMinor = 100;//f
	numPlanet = 8;
	numSatellite = 3;
	numRigid0 = 2 + numPlanet + numSatellite + numMinor;//2͑zƓẙ
	numStrobo = 100;
	numRigid = numRigid0 + numStrobo;//100̓Xg{p

	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	double C = 160.0;//640.0;//߂萔
	//ziSɌŒj
	rigid[0].vSize = CVector(15.0, 15.0, 15.0);
	rigid[0].vPos = CVector(0.0, 0.0, 0.0);
	rigid[0].vOmega = CVector(0.0, sin(7.15 * pp), cos(7.15 * pp)) * M_PI / 2.0;//]
	rigid[0].vEuler = CVector(-7.15, 0.0, 0.0);
	rigid[0].q = getQFromEulerXYZ(rigid[0].vEuler) * rigid[0].q;
	//
	rigid[1].radius = 20.0;
	rigid[1].period = sqrt(pow((double)rigid[1].radius, 3.0) / C) ;
	rigid[1].vSize = CVector(3.0, 3.0, 3.0);
	rigid[1].vPos = CVector(0.0, -20.0, 0.0);
	rigid[1].vOmega = CVector(0.0, 0.0, 1.0) * M_PI / 4.0;
	rigid[1].vEuler = CVector(0.0, 0.0, 0.0);
	rigid[1].q = getQFromEulerXYZ(rigid[1].vEuler) * rigid[1].q;
	//
	rigid[2].radius = 30.0;
	rigid[2].period = sqrt(pow((double)rigid[2].radius, 3.0) / C);
	rigid[2].vSize = CVector(4.0, 4.0, 4.0);
	rigid[2].vPos = CVector(0.0, -30.0, 0.0);
	rigid[2].vOmega = CVector(0.0, sin(2.7 * pp), cos(2.7 * pp)) * (-M_PI) / 10.0;//(t]j
	rigid[2].vEuler = CVector(-2.7, 0.0, 0.0);
	rigid[2].q = getQFromEulerXYZ(rigid[2].vEuler) * rigid[2].q;
	//n
	rigid[3].radius = 40.0;
	rigid[3].period = sqrt(pow((double)rigid[3].radius, 3.0) / C) ;
	rigid[3].vSize = CVector(4.0, 4.0, 4.0);
	rigid[3].vPos = CVector(0.0, -40.0, 0.0);
	rigid[3].vOmega = CVector(0.0, sin(23.4 * pp), cos(23.4 * pp)) * M_PI * 2.0;
	rigid[3].vEuler = CVector(-23.4, 0.0, 0.0);
	rigid[3].q = getQFromEulerXYZ(rigid[3].vEuler) * rigid[3].q;
	
	//ΐ
	rigid[4].radius = 50.0;
	rigid[4].period = sqrt(pow((double)rigid[4].radius, 3.0) / C) ;
	rigid[4].vSize = CVector(3.2, 3.2, 3.2);
	rigid[4].vPos = CVector(0.0, -50.0, 0.0);
	rigid[4].vOmega = CVector(0.0, sin(25.2 * pp), cos(25.2 * pp)) * M_PI;//K
	rigid[4].vEuler = CVector(-25.2, 0.0, 0.0);
	rigid[4].q = getQFromEulerXYZ(rigid[4].vEuler) * rigid[4].q;
	//ؐ
	rigid[5].radius = 80.0;
	rigid[5].period = sqrt(pow((double)rigid[5].radius, 3.0) / C) ;
	rigid[5].vSize = CVector(8.0, 8.0, 8.0);
	rigid[5].vPos = CVector(0.0, -rigid[5].radius, 0.0);
	rigid[5].vOmega = CVector(0.0, sin(3.1 * pp), cos(3.1 * pp)) * M_PI * 2.4;//K
	rigid[5].vEuler = CVector(-3.1, 0.0, 0.0);
	rigid[5].q = getQFromEulerXYZ(rigid[5].vEuler) * rigid[5].q;
	//y
	rigid[6].radius = 100.0;
	rigid[6].period = sqrt(pow((double)rigid[6].radius, 3.0) / C) ;
	rigid[6].vSize = CVector(7.5, 7.5, 7.5);
	rigid[6].vPos = CVector(0.0, -rigid[6].radius, 0.0);
	rigid[6].vOmega = CVector(0.0, sin(26.7 * pp), cos(26.7 * pp)) * M_PI * 2.25;//K
	rigid[6].vEuler = CVector(-26.7, 0.0, 0.0);
	rigid[6].q = getQFromEulerXYZ(rigid[6].vEuler) * rigid[6].q;
	//ẙ
	rigid[9].kind = TORUS;
	rigid[9].radius = 100.0;
	rigid[9].period = sqrt(pow((double)rigid[9].radius, 3.0) / C) ;
	rigid[9].vSize = CVector(14.0, 14.0, 1.0);
	rigid[9].vPos = CVector(0.0, -rigid[9].radius, 0.0);
	rigid[9].vOmega = CVector(0.0, sin(26.7 * pp), cos(26.7 * pp)) * M_PI * 2.25;//K
	rigid[9].vEuler = CVector(-26.7, 0.0, 0.0);
	rigid[9].q = getQFromEulerXYZ(rigid[9].vEuler) * rigid[9].q;
	//V
	rigid[7].radius = 120.0;
	rigid[7].period = sqrt(pow((double)rigid[7].radius, 3.0) / C) ;
	rigid[7].vSize = CVector(6.0, 6.0, 6.0);
	rigid[7].vPos = CVector(0.0, -rigid[7].radius, 0.0);
	rigid[7].vOmega = CVector(0.0, 1.0, 0.0) * M_PI * 1.5;//K
	rigid[7].vEuler = CVector(90.0, 0.0, 0.0);
	rigid[7].q = getQFromEulerXYZ(rigid[7].vEuler) * rigid[7].q;
	//C
	rigid[8].radius = 140.0;
	rigid[8].period = sqrt(pow((double)rigid[8].radius, 3.0) / C) ;
	rigid[8].vSize = CVector(6.0, 6.0, 6.0);
	rigid[8].vPos = CVector(0.0, -rigid[8].radius, 0.0);
	rigid[8].vOmega = CVector(0.0, sin(29.6 * pp), cos(29.6 * pp)) * M_PI * 1.6;//K
	rigid[8].vEuler = CVector(-29.6, 0.0, 0.0);
	rigid[8].q = getQFromEulerXYZ(rigid[8].vEuler) * rigid[8].q;

	//q
	//
	rigid[10].radius = 3.5;//nS̋
	rigid[10].period = rigid[3].period / 12.0;
	rigid[10].vSize = CVector(2.0, 2.0, 2.0);
	rigid[10].vPos = CVector(0.0, -rigid[10].radius, 0.0) + rigid[3].vPos;
	rigid[10].vOmega = CVector(0.0, 0.0, 1.0) * 2.0*M_PI / rigid[10].period;//K

	//ؐ̉q
	rigid[11].radius = 5.5;//ؐS̋
	rigid[11].period = 1.0;
	rigid[11].vSize = CVector(2.0, 2.0, 2.0);
	rigid[11].vPos = CVector(0.0, -rigid[11].radius, 0.0) + rigid[5].vPos;
	//V̉q
	rigid[12].radius = 4.5;//VS̋
	rigid[12].period = 1.0;
	rigid[12].vSize = CVector(2.0, 2.0, 2.0);
	rigid[12].vPos = CVector(0.0, 0.0, rigid[12].radius) + rigid[7].vPos;
	//f
	srand(0);
	for(i = 2+numPlanet+numSatellite; i < 2+numPlanet+numSatellite+numMinor/2; i++)
	{
		rigid[i].kind = BOX;
		rigid[i].vSize = CVector(1.0, 1.0, 1.0);
		rigid[i].radius = getRandom(63.0, 67.0);
		rigid[i].phase0 = getRandom(0.0, 2.0 * M_PI);
		rigid[i].vPos.x = rigid[i].radius * cos(rigid[i].phase0);
		rigid[i].vPos.y = rigid[i].radius * sin(rigid[i].phase0);
		rigid[i].period = sqrt(pow((double)rigid[i].radius, 3.0) / C) ;
		rigid[i].vOmega = CVector(0.0, 0.0, getRandom(0.1, 1.0)) * M_PI;//K
	}
	for(i =  2+numPlanet+numSatellite+numMinor/2; i < numRigid0; i++)
	{
		rigid[i].kind = CONE;
		rigid[i].vSize = CVector(1.0, 1.0, 1.0);
		rigid[i].radius = getRandom(63.0, 67.0);
		rigid[i].phase0 = getRandom(0.0, 2.0 * M_PI);
		rigid[i].vPos.x = rigid[i].radius * cos(rigid[i].phase0);
		rigid[i].vPos.y = rigid[i].radius * sin(rigid[i].phase0);
		rigid[i].period = sqrt(pow((double)rigid[i].radius, 3.0) / C) ;
		rigid[i].vOmega = CVector(0.0, 0.0, getRandom(0.1, 1.0)) * M_PI;//K
	}

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		if(((i-numRigid0) / 2) * 2 == i - numRigid0) 
		{
			rigid[i].color = YELLOW;
			rigid[i].vSize = CVector(1.0, 1.0, 1.0);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
		else
		{
			rigid[i].color = CYAN;
			rigid[i].vSize = CVector(1.0, 1.0, 1.0);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
	}

}

void setTexture(int n)
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
   //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[n]);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
//  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
	lightPos[0] = -rigid[selNo].vPos.x;
	lightPos[1] = -rigid[selNo].vPos.y;
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	//texture unit  texture object ̊֘At
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);
	glActiveTexture(GL_TEXTURE3);
  glBindTexture(GL_TEXTURE_2D, texName[3]);
  glActiveTexture(GL_TEXTURE4);
  glBindTexture(GL_TEXTURE_2D, texName[4]);
  glActiveTexture(GL_TEXTURE5);
  glBindTexture(GL_TEXTURE_2D, texName[5]);
	glActiveTexture(GL_TEXTURE6);
  glBindTexture(GL_TEXTURE_2D, texName[6]);
  glActiveTexture(GL_TEXTURE7);
  glBindTexture(GL_TEXTURE_2D, texName[7]);
  glActiveTexture(GL_TEXTURE8);
  glBindTexture(GL_TEXTURE_2D, texName[8]);
	glActiveTexture(GL_TEXTURE9);
  glBindTexture(GL_TEXTURE_2D, texName[9]);
  glActiveTexture(GL_TEXTURE10);
  glBindTexture(GL_TEXTURE_2D, texName[10]);

  //`
  // VF[_vO̓Kp 
	glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	GLint sunLoc = glGetUniformLocation(shaderProg, "sun");
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	glUniform1i(selLoc, 1);
	for(int i = 0; i < numRigid0; i++)
	{
		rigid[i].select = true;
		if(i == 0) glUniform1i(sunLoc, 1);
		else       glUniform1i(sunLoc, 0);
		glUniform1i(imageLoc, i);//GL_TEXTUREiKp
		if(i >= 10) glUniform1i(imageLoc, 10);
		rigid[i].draw();
	}
	if(flagStrobo)
	{
		for(int i = numRigid0; i < numRigid; i++)
		{
			glUniform1i(selLoc, 0);
			rigid[i].draw();
		}
	}

  glUseProgram(0);
	worldX = rigid[selNo].vPos.x;
	worldY = rigid[selNo].vPos.y;

	CVector vPos1;

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
	  elapseTime2 += dt;
		//zƘf̎]
		rigid[0].attraction(timeStep);
		for(int i = 1; i < 10; i++)
		{
			rigid[i].attraction(timeStep);//]
			rigid[i].vPos.x = rigid[i].radius * sin(2.0 * M_PI * elapseTime2 * timeRate / rigid[i].period);
			rigid[i].vPos.y = rigid[i].radius * cos(2.0 * M_PI * elapseTime2 * timeRate / rigid[i].period - M_PI);
		}
		//̋O
		rigid[10].attraction(timeStep);//]
		vPos1.x = rigid[10].radius * sin(2.0 * M_PI * elapseTime2 * timeRate / rigid[10].period);
		vPos1.y = rigid[10].radius * cos(2.0 * M_PI * elapseTime2 * timeRate / rigid[10].period - M_PI);
		vPos1.rotX(5.0);//̌_Oʂ͒ň_Oʂɑ΂5xXĂ
		rigid[10].vPos =  vPos1 + rigid[3].vPos ;
		//ؐ̉q
		rigid[11].attraction(timeStep);//]
		vPos1.x = rigid[11].radius * sin(2.0 * M_PI * elapseTime2 * timeRate / rigid[11].period);
		vPos1.y = rigid[11].radius * cos(2.0 * M_PI * elapseTime2 * timeRate / rigid[11].period - M_PI);
		vPos1.rotX(-3.1);
		rigid[11].vPos =  vPos1 + rigid[5].vPos ;
		//V̉q
		rigid[12].attraction(timeStep);//]
		vPos1.x = rigid[12].radius * sin(2.0 * M_PI * elapseTime2 * timeRate / rigid[12].period);
		vPos1.y = rigid[12].radius * cos(2.0 * M_PI * elapseTime2 * timeRate / rigid[12].period - M_PI);
		vPos1.rotX(-90.0);
		rigid[12].vPos =  vPos1 + rigid[7].vPos ;
		//f
		for(int i = 2+numPlanet+numSatellite; i < numRigid0; i++)
		{
			rigid[i].attraction(timeStep);//]
		rigid[i].vPos.x = rigid[i].radius * cos(rigid[i].phase0 + 2.0 * M_PI * elapseTime2 * timeRate / rigid[i].period);
		rigid[i].vPos.y = rigid[i].radius * sin(rigid[i].phase0 + 2.0 * M_PI * elapseTime2 * timeRate / rigid[i].period);
		}

		if(flagOneStep) flagFreeze = true;
	
		if(flagStrobo)
		{
			if(countStrobo < numStrobo)
			{
				if( timeStrobo == 0.0) 
				{
						if((countStrobo/2) * 2 == countStrobo) rigid[numRigid0 + countStrobo].vPos = rigid[3].vPos;
						else                                   rigid[numRigid0 + countStrobo].vPos = rigid[10].vPos;
				}

				timeStrobo += dt;
				if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
				if(countStrobo >= numStrobo) countStrobo = 0;
			}
		}
	}

  glDisable(GL_LIGHTING);
	if(flagFloor) glCallList(grid0);//iq
  glEnable(GL_LIGHTING);

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'z':
		rigid[selNo].select = 0;
		selNo++;
		if(selNo == 8) selNo = 0;
		rigid[selNo].select = 1;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
}

