#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform float size;

void main()
{
	vec2 texPos = gl_Vertex.xy;

	vec4 vel = texture2DRect(samplerVel, texPos);
	vec4 pos = texture2DRect(samplerPos, texPos) ;//_̍W
	gl_Position = gl_ModelViewProjectionMatrix * vec4(pos.xyz, 1.0);
  vec4 eyeCoord = gl_ModelViewMatrix * vec4(pos.xyz, 1.0);//_Wn
  float dist = length(eyeCoord.xyz);//Ji_j܂ł̋
  
  float att = sqrt(1.0 / (gl_Point.distanceConstantAttenuation +
                         (gl_Point.distanceLinearAttenuation +
                          gl_Point.distanceQuadraticAttenuation * dist) * dist));
                          
	gl_Point.size = size * vel.a;//ʏŁCKȑ傫ɂȂ悤ɌW߂
	
	float size = clamp(gl_Point.size * att, gl_Point.sizeMin, gl_Point.sizeMax);
	gl_PointSize = max(size, gl_Point.fadeThresholdSize);
	
	gl_FrontColor = gl_Color;
}
