
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform float GM;
uniform float dt;
uniform float time;//oߎ
varying vec2 texPos;

void main(void)
{
	vec4 position, velocity;
	int i, j;
	float dist;
	vec3 accel = vec3(0.0, 0.0, 0.0);
	position = texture2DRect(samplerPos, texPos);	
	velocity = texture2DRect(samplerVel, texPos);
	
	//͒Sɑ΂͂l
	dist = length(position.xyz);
	if(time >= position.w)
	{
		accel.xyz -= normalize(position.xyz) * GM / dist;
		velocity.xyz += accel * dt;
	}
		
	gl_FragColor = velocity;
}
