
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCol;
uniform int texWidth, texHeight;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, position0, velocity, color;
	position = texture2DRect(samplerPos, texPos);		
	velocity = texture2DRect(samplerVel, texPos);
	color = texture2DRect(samplerCol, texPos);
	float dist;

	if(texPos.x < float(texWidth/2) && texPos.y < float(texHeight/2))
	{
		//Q
		position0 = texture2DRect(samplerPos, vec2(0.0, 0.0));//SW
		//S̋
		dist = length(position.xyz - position0.xyz);

		if(dist > 0.5)//S͌Œ
		{
			if(color.a == -1.0) //halö͎ԍ
			{ 
				if(time >= position.w) position.xyz += velocity.xyz * dt;
			}
			else position.xyz += velocity.xyz * dt;
		}
	}

	else if(texPos.x >= float(texWidth/2) && texPos.y < float(texHeight/2))
	{
		//_Q
		position0 = texture2DRect(samplerPos, vec2(float(texWidth/2), 0.0));//SW
		//S̋
		dist = length(position.xyz - position0.xyz);

		if(dist > 0.5)//S͌Œ
		{
			if(color.a == -1.0)//halö͎ԍ
			{ 
				if(time >= position.w) position.xyz += velocity.xyz * dt;
			}
			else position.xyz += velocity.xyz * dt;
		}
	}

	else if(texPos.x < float(texWidth/2) && texPos.y >= float(texHeight/2))
	{
		//No=2(Y)
		position0 = texture2DRect(samplerPos, vec2(0.0, float(texHeight/2)));//Sʒu

		//S̋
		dist = length(position.xyz - position0.xyz);
		
		if(dist > 0.5)//S͌Œ
		{
			if(color.a == -1.0) //halö͎ԍ
			{
				if(time >= position.w)
				 position.xyz += velocity.xyz * dt;
			}
			else position.xyz += velocity.xyz * dt;
		}
	}
	else
	{
		//No=3(ȉ~)
		position0 = texture2DRect(samplerPos, vec2(float(texWidth/2), float(texHeight/2)));//Sʒu
		//͒S̋
		dist = length(position.xyz - position0.xyz);
		if(dist > 0.5 && time >= position.w) position.xyz += velocity.xyz * dt;
	}
	
	
	
	
	gl_FragColor = position;		
}
