
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCol;
uniform int texWidth, texHeight;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, position0, position1, velocity, color;
	//vec3 delta0;
	position = texture2DRect(samplerPos, texPos);		
	velocity = texture2DRect(samplerVel, texPos);
	color = texture2DRect(samplerCol, texPos);
	

	position0 = texture2DRect(samplerPos, vec2(0.0, 0.0));//0ɑ΂钆SW
	position1 = texture2DRect(samplerPos, vec2(0.0, float(texHeight/2)));//1ɑ΂钆SW
	float d = length(position1.xyz - position0.xyz);
	if(d < 1.0) position.w = 1.0;//
	//ꂼ̒S̋
	float dist0 = length(position.xyz - position0.xyz);
	float dist1 = length(position.xyz - position1.xyz);
	//͒S̈ʒuXV
	if((texPos.x == 0.0 && texPos.y == 0.0) || (texPos.x == 0.0 && texPos.y ==  float(texHeight/2)))
	{
		if(position.w == 0.0)//d > 1.0)
			position.xyz += velocity.xyz * dt;
		else 
		{
			if(texPos.x == 0.0 && texPos.y == 0.0) position.xyz = normalize(position0-position1) ;
			else position.xyz = normalize(position1-position0) ;
		}
	}
	else//qij
	{
		if(dist0 > 0.5 && dist1 > 0.5)//S͌Œ
		{
			position.xyz += velocity.xyz * dt;
		}
	}
	


	gl_FragColor = position;		
}
