/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

fn`V~[V
ׂĂ̘f͑z̈͂󂯂D
fǂ͋߂̂Ɉ͂^
Փ˂Ƃ
PointSprite𗘗pClvZɂGLSLgp
*/
#define FILENAME_IN "../../bmp/particle.bmp"


#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../setupGP.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void initObject();
void setTextureVel();
void setTexturePos();
void setFramebufferVel();
void setFramebufferPos();
void setTextureSprite();
void drawNumberingPoints();
void drawSprite();
void renewVelocity(float dt);
void renewPosition(float dt);

//f[^̃TCY
int texWidth, texHeight;//͗p
int imgWidth, imgHeight;//particlẽeNX`
//particle
int numPoint;

//͗pf[^z
float *velocity, *position;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][4];
//VF[_vO
GLuint program1, program2, program3;
GLuint texID[3];//texture object
GLuint fb[2];//frame buffer object 

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum ternalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;
GLenum type = GL_FLOAT;

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

float GM = 10000.0;
float G_CONST = 0.001;//L͒萔
float MASS = GM / G_CONST;
float distEffect = 15.0;//15.0;
float	constMR = 0.06;//->aϊ̔萔(̒l傫Ɛcf͏ȂȂj
int numPlanet;//cf

double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("GP_PlanetaryCreation1");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
	initGlsl(&program1, "simulation.vert", "velocity.frag");
	initGlsl(&program2, "simulation.vert", "position.frag");
	initGlsl(&program3, "rendering.vert");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
 	free(velocity);
	free(position);
	glDeleteLists(grid0, 1);
	glDeleteTextures(3, texID);
	glDeleteFramebuffersEXT(2, fb);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
	glDeleteProgram(program3);
	return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.11, 1.0);

  setCamera();//_߂
//  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 350.0;//80.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 80.0;
	view.phi = 0.0;
	setCamera();
	view.nearZ = 10.0;
	view.farZ = 1000.0;
	view0 = view;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);
 
	glGenTextures(3, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(2, fb);

	//point sprite ̃eNX`[
	loadColorData32(image, &imgWidth, &imgHeight, FILENAME_IN);
  for(int j = 0; j < imgHeight; j++)
  {
		for(int i = 0; i < imgWidth; i++)
    {
			int n = i + j * imgHeight;
		  if( image[n][0] == 0 && image[n][1] == 0 &&  image[n][2] == 0) image[n][3] = 0; 
		  else image[n][3] = 255;
		}
	}
  setTextureSprite();

	//\EBhEɕ_O鏀
	setFontBitmaps();
	//display list쐬
	createGrid();

	initObject();

	//L[̐
	printf("L[ɂʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
	printf("[F1]key:GMς̑ \n");
	printf("[F2]key:ʂ̏dɕבւ \n");

}

void initObject()
{
  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ

	//particlȅl쐬
	texWidth =  15;//30;//WeNX`̉TCY
	texHeight = 15;//30;//WeNX`̏cTCY
	numPoint = texWidth * texHeight;//Š(numStrobo܂ށj
	numPlanet = numPoint - 1;//1͑z

	velocity = (float*)malloc(4 * texWidth * texHeight * sizeof(float));
	position = (float*)malloc(4 * texWidth * texHeight * sizeof(float));

	//position and velocity;
	//sun
	position[0] = 0.0; position[1] = 0.0; position[2] = 0.0; position[3] = 0.0;
	velocity[0] = 0.0; velocity[1] = 0.0; velocity[2] = 0.0; velocity[3] = MASS;
	//planet
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			int k = i + j * texWidth;
			if(i == 0 && j == 0) continue;//sun 
			CVector vPos = getRandomRingVectorXY(20.0, 150.0);
			position[k * 4 + 0] = vPos.x;
			position[k * 4 + 1] = vPos.y;
			position[k * 4 + 2] = 0.0;
			position[k * 4 + 3] = 0.0;
			CVector vTan = vCross(CVector(0.0, 0.0, 1.0), vPos).norm2();//ڐ
			double r = vPos.magnitudeXY();
			CVector vVel = vTan * (sqrt((double)(GM) / r));
			velocity[k * 4 + 0] = vVel.x;
			velocity[k * 4 + 1] = vVel.y;
			velocity[k * 4 + 2] = 0.0;//
			velocity[k * 4 + 3] = getRandom(0.1, 1.0) * MASS / 1000.0;//
		}

	setTextureVel();
	setTexturePos();
	setFramebufferVel();
	setFramebufferPos();
	flagStart = false;
	flagFreeze = false;
}

void setTextureVel()
{//͗p
  glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, ternalFormat, texWidth, texHeight, 0, format, type, velocity);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}
void setTexturePos()
{//͗p
  glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, ternalFormat, texWidth, texHeight, 0, format, type, position);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}

void setFramebufferVel()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setFramebufferPos()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureSprite()
{
  glBindTexture(GL_TEXTURE_2D, texID[2]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,imgWidth,imgHeight,0,GL_RGBA,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  //F̒i̐ݒj
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
  //Sprite
  glTexEnvi(GL_POINT_SPRITE, GL_COORD_REPLACE, GL_TRUE);
  
  // At@eXg̔ʊ֐ 
  glAlphaFunc(GL_GREATER, 0.5);

  //point sprite̻ނ
	glPointParameterf(GL_POINT_SIZE_MIN, 1.0);
	glPointParameterf(GL_POINT_SIZE_MAX, 1000.0);
  float atten[] = {0.0, 0.0, 0.001};
  glPointParameterfvEXT(GL_POINT_DISTANCE_ATTENUATION, atten);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
/*
if((int)elapseTime2 == 0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 10.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 20.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 30.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 50.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 70.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 100.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 150.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 200.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 300.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 500.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 700.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 1000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 2000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 3000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 5000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//1.39
if((int)elapseTime2 == 10000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//2.78
if((int)elapseTime2 == 20000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 50000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//13.89
*/
  }
  QueryPerformanceCounter( &lastTime);

	timeStep = dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
		elapseTime2 += dt;

		//step1:x̍XV
		renewVelocity(timeStep);

		//step2:ʒu̍XV
		renewPosition(timeStep);

		if(flagOneStep) flagFreeze = true;

	}

	//Step3:rendering.vertœ_`
  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
//	glDrawBuffer(GL_BACK);
	resize(width, height);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  //`	
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//xf[^
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//ʒuf[^
  glUseProgram(program3);
	GLint samplerVelLoc = glGetUniformLocation(program3, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
	GLint samplerPosLoc = glGetUniformLocation(program3, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, texID[2]);

	drawSprite();
  
	glBindTexture(GL_TEXTURE_2D, 0);
	
  glUseProgram(0);
  glBindTexture(target, 0);

	glDisable(GL_LIGHTING);
	if(flagFloor) glCallList(grid0);//FԍW
	glEnable(GL_LIGHTING);

	if(flagCoord) 
	{
		drawWorldCoordinates(15.0);//W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("elapseTime2=%d[s]", (int)elapseTime2, 200, 30);
		drawParam("numPlanet=%d", numPlanet, 400, 30);
		drawParam("GM=%3.1f", GM, 20, 60);
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}

void renewVelocity(float dt)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position

  glUseProgram(program1);
  GLint samplerVelLoc = glGetUniformLocation(program1, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program1, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint widthLoc = glGetUniformLocation(program1, "texWidth");
	glUniform1i(widthLoc, texWidth);
	GLint heightLoc = glGetUniformLocation(program1, "texHeight");
	glUniform1i(heightLoc, texHeight);
	GLint gravityLoc = glGetUniformLocation(program1, "G_CONST");
	glUniform1f(gravityLoc, G_CONST);
	GLint distLoc = glGetUniformLocation(program1, "distEffect");
	glUniform1f(distLoc, distEffect);
	GLint constLoc = glGetUniformLocation(program1, "constMR");
	glUniform1f(constLoc, constMR);
	GLint dtLoc = glGetUniformLocation(program1, "dt");
	glUniform1f(dtLoc, dt);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, GL_FLOAT, velocity);

	glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//cf
	numPlanet = 0;
	for(int k = 1; k < numPoint; k++)
	{
		if(velocity[4*k+3] != 0.0) numPlanet ++;
	}

}

void renewPosition(float dt)
{
	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
  glUseProgram(program2);
  GLint samplerVelLoc = glGetUniformLocation(program2, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program2, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint dtLoc = glGetUniformLocation(program2, "dt");
	glUniform1f(dtLoc, dt);
//printf("numPlanet0=%d \n", numPlanet0);
	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, GL_FLOAT, position);

  glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}


void drawNumberingPoints()
{
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	//ʂeNX`Ƃē\tIuWFNg(qԍʁj
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_Wqԍ
  glEnd();
}

void drawSprite()
{
	//glDisable(GL_LIGHTING);
	glEnable(GL_VERTEX_PROGRAM_POINT_SIZE);
  glEnable(GL_POINT_SPRITE);//|CgXvCgL
  glEnable(GL_TEXTURE_2D);  //eNX`}bsOL
  glEnable(GL_ALPHA_TEST);  //At@eXgL
  
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			if(i == 0 && j == 0) glColor3f(1.0, 0.0, 0.0);
			else glColor3f(0.0, 1.0, 1.0);
			glVertex2f((float)i, (float)j);
		}
  glEnd();
  glDisable(GL_ALPHA_TEST);
  glDisable(GL_POINT_SPRITE);
  glDisable(GL_TEXTURE_2D);

	glDisable(GL_VERTEX_PROGRAM_POINT_SIZE);
	//glEnable(GL_LIGHTING);
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
//		for(int i = 0; i < 3; i++)lightPos[i] = lightPos0[i];
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) GM += 100.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) GM -= 100.0;
		if(GM < 100) GM = 100.0;
		
		initObject();
	}

	float mass;
	CVector pos, vel, size;
	if(key == GLUT_KEY_F2)
	{
		flagFreeze = true;
		for(int k = 1; k < 3; k++)
		{
			for(int i = k+1; i < numPoint;i++)
			{
			  if(velocity[4*i+3] == 0.0) continue;
				if(velocity[4*i+3] > velocity[4*k+3]) 
				{
					mass = velocity[4*k+3];
					pos.x = position[4*k];
					pos.y = position[4*k+1];
					vel.x = velocity[4*k];
					vel.y = velocity[4*k+1];
					velocity[4*k+3] = velocity[4*i+3];//mass
					position[4*k] = position[4*i];//pos.x
					position[4*k+1] = position[4*i+1];//pos.y
					velocity[4*k] = velocity[4*i];//vel.x;
					velocity[4*k+1] = velocity[4*i+1];//vel.y;

					velocity[4*i+3] = mass;
					position[4*i] = pos.x;
					position[4*i+1] = pos.y;
					velocity[4*i] = vel.x;
					velocity[4*i+1] = vel.y;
				}
			}
		}
		flagFreeze = false;
		printf("1  x=%f, y=%f \n", position[4*1], position[4*1+1]);
		printf("2  x=%f, y=%f \n", position[4*2], position[4*2+1]);
		printf("mass1=%f, mass2=%f \n", velocity[4*1+3], velocity[4*2+3]);
	}
}

