
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform float dt;
varying vec2 texPos;

void main(void)
{
	vec4 position, velocity, normal;

	position = texture2DRect(samplerPos, texPos);		
	velocity = texture2DRect(samplerVel, texPos);
	if(velocity.w == 0.0) return;
	
	position.xy += velocity.xy * dt;
	
	gl_FragColor = position;		
}
