
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;

void main()
{
	vec2 texPos = gl_Vertex.xy;

	vec4 vel = texture2DRect(samplerVel, texPos);
	vec4 pos = texture2DRect(samplerPos, texPos) ;//_̍W
  vec4 eyeCoord = gl_ModelViewMatrix * vec4(pos.xy, 0.0, 1.0);
	gl_Position = gl_ModelViewProjectionMatrix * vec4(pos.xy, 0.0, 1.0);

  float dist = length(eyeCoord.xyz);
  float att = sqrt(1.0 / (gl_Point.distanceConstantAttenuation +
                         (gl_Point.distanceLinearAttenuation +
                          gl_Point.distanceQuadraticAttenuation * dist) * dist));

	//ʂɔႵTCYɕϊ
	gl_Point.size = 3.0 * pow(vel.w , 0.333);//ʏŁCݒ肵TCYɈv悤ɌW߂
	float size = clamp(gl_Point.size * att, gl_Point.sizeMin, gl_Point.sizeMax);
	gl_PointSize = max(size, gl_Point.fadeThresholdSize);

//gl_PointSize = 0.1 * pow(vel.w , 0.333);
	gl_FrontColor = gl_Color;	
}
