
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCol;
uniform float GM;
uniform float bulgeRadius;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, velocity, color;
	int i, j;
	float dist;
	vec3 omega;
	vec3 accel = vec3(0.0, 0.0, 0.0);
	position = texture2DRect(samplerPos, texPos);	
	velocity = texture2DRect(samplerVel, texPos);
	color = texture2DRect(samplerCol, texPos);
	
	//͒S̋
	dist = length(position.xyz);
	
	if(color.a == -1.0)//halö͎ԍ
	{
		if(time >= position.w) accel.xyz -= normalize(position.xyz) * GM / dist;
	}
	else
	{
		if(color.a == 0.0) accel.xyz -= normalize(position.xyz) * GM / dist;//ʂ̗q
		else accel.xyz -= normalize(position.xyz) * (GM/1000.0) / dist;//Qrq
	}
	velocity.xyz += accel.xyz * dt;
	
	gl_FragColor = velocity;
}
