//parametersSolar.h

//
float e = 0.0;
float muK = 0.5;

//̑
//world coordinateš_
float worldX = 0.0;
float worldY = 0.0;
//floor
float floorMinX = -100.0;
float floorMaxX =  100.0;
float floorMinY = -100.0;
float floorMaxY =  100.0;
//
//IIuWFNgԍ
int selNo = 0;

enum Kind {SPHERE, ELLIPSOID, CUBE, BOX, CYLINDER, COLUMN, TORUS, CONE, PYRAMID};
enum Color {RED, GREEN, BLUE, YELLOW, CYAN, MAGENTA, WHITE};

float red[] = {0.8, 0.1, 0.1, 1.0};
float green[] = {0.1, 0.8, 0.1, 1.0};
float blue[] = {0.1, 0.1, 0.8, 1.0};
float yellow[] = {0.8, 0.8, 0.1, 1.0};
float cyan[] = {0.1, 0.8, 0.8, 1.0};
float magenta[] = {0.8, 0.1, 0.8};
float white[] = {0.9, 0.9, 0.9, 1.0};

//display list
int sphere, cube, box, cylinder, column, torus, cone, pyramid, koma, floor0, grid0;
int sphereTex, cubeTex, boxTex, cylinderTex, columnTex, torusTex, coneTex, pyramidTex, komaTex;

void createSphere()
{
	sphere = glGenLists(1);
	if(sphere == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(sphere, GL_COMPILE);
	drawSphere(0.5, 16, 16);
	glEndList();
}
void createCube()
{
	cube = glGenLists(1);
	if(cube == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cube, GL_COMPILE);
	drawCube(1.0);
	glEndList();
}
//pɊۂ݂̂钼(Փ˔莞CUBEƂȂf[^\j
float boxEps1 = 0.1;
float boxEps2 = 0.1;
void createBox()
{
	box = glGenLists(1);
	if(box == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(box, GL_COMPILE);
	drawSuper(0.5, 10, 10, boxEps1, boxEps2);
	glEndList();
}

void createCylinder()
{
	cylinder = glGenLists(1);
	if(cylinder == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cylinder, GL_COMPILE);
	drawCylinder(0.5, 0.5, 1.0, 12, 4);
	glEndList();
}
//pɊۂ݂̂~
float columnEps1 = 0.1;//0.5;
float columnEps2 = 1.0;//0.5;//1.0;
void createColumn()
{
	column = glGenLists(1);
	if(column == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(column, GL_COMPILE);
	drawSuper(0.5, 10, 10, columnEps1, columnEps2);
	glEndList();
}

float ratioTorus = 0.4;//0.5;
void createTorus()
{
	torus = glGenLists(1);
	if(torus == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(torus, GL_COMPILE);
  drawTorus(ratioTorus * 0.5, 0.5, 20, 20);
	glEndList();
}
//pɊۂ݂̂Ώ̃s~bh
float pyramidEps1 = 1.9;//2.0;
float pyramidEps2 = 0.25;//0.2;
void createPyramid()
{
	pyramid = glGenLists(1);
	if(pyramid== 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(pyramid, GL_COMPILE);
	drawSuper(0.5, 10, 10, pyramidEps1, pyramidEps2);
	glEndList();
}
//pɊۂ݂̂Ώ̉~
float coneEps1 = 1.9;//2.0;
float coneEps2 = 1.0;
void createCone()
{
	cone = glGenLists(1);
	if(cone == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cone, GL_COMPILE);
	drawSuper(0.5, 10, 10, coneEps1, coneEps2);
	glEndList();
}

//for texture
void createSphereTex()
{
	sphereTex = glGenLists(1);
	if(sphereTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(sphereTex, GL_COMPILE);
	drawTexSphere2(0.5, 16, 16, 1, 1);
	glEndList();
}
void createCubeTex()
{
	cubeTex = glGenLists(1);
	if(cubeTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cubeTex, GL_COMPILE);
	drawTexCube2(1.0, 1, 1);
	glEndList();
}
//pɊۂ݂̂钼(Փ˔莞CUBEƂȂf[^\j
void createBoxTex()
{
	boxTex = glGenLists(1);
	if(boxTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(boxTex, GL_COMPILE);
	drawTexSuper(0.5, 10, 10, boxEps1, boxEps2);
	glEndList();
}

void createCylinderTex()
{
	cylinderTex = glGenLists(1);
	if(cylinderTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cylinderTex, GL_COMPILE);
	drawTexCylinder1(0.5, 0.5, 1.0, 12, 4, 1, 1);
	glEndList();
}
void createColumnTex()
{
	columnTex = glGenLists(1);
	if(columnTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(columnTex, GL_COMPILE);
	drawTexSuper(0.5, 10, 10, columnEps1, columnEps2);
	glEndList();
}

void createTorusTex()
{
	torusTex = glGenLists(1);
	if(torusTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(torusTex, GL_COMPILE);
	drawTexTorus(ratioTorus * 0.5, 0.5, 8, 16, 1,1);
	glEndList();
}
//pɊۂ݂̂Ώ̉~
void createConeTex()
{
	coneTex = glGenLists(1);
	if(coneTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(coneTex, GL_COMPILE);
	drawTexSuper(0.5, 10, 10, coneEps1, coneEps2);
	glEndList();
}
//pɊۂ݂̂Ώ̃s~bh
void createPyramidTex()
{
	pyramidTex = glGenLists(1);
	if(pyramidTex == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(pyramidTex, GL_COMPILE);
	drawTexSuper(0.5, 10, 10, pyramidEps1, pyramidEps2);
	glEndList();
}
void createGrid()
{
	grid0 = glGenLists(1);
	if(grid0 == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(grid0, GL_COMPILE);
	drawGridZ(floorMaxX - floorMinX, floorMaxY - floorMinY, 20, 20);
	glEndList();
}

void createDisplayLists()
{
	createSphere();
	createCube();
	createCylinder();
	createBox();
	createColumn();
	createTorus();
	createCone();
	createPyramid();
	createSphereTex();
	createCubeTex();
	createCylinderTex();
	createBoxTex();
	createColumnTex();
	createTorusTex();
	createConeTex();
	createPyramidTex();
	createGrid();
}
void deleteDisplayLists()
{
	glDeleteLists(sphere, 1);
	glDeleteLists(cube, 1);
	glDeleteLists(cylinder, 1);
	glDeleteLists(box, 1);
	glDeleteLists(column, 1);
	glDeleteLists(torus, 1);
	glDeleteLists(cone, 1);
	glDeleteLists(pyramid, 1);
	glDeleteLists(sphereTex, 1);
	glDeleteLists(cubeTex, 1);
	glDeleteLists(cylinderTex, 1);
	glDeleteLists(boxTex, 1);
	glDeleteLists(columnTex, 1);
	glDeleteLists(torusTex, 1);
	glDeleteLists(coneTex, 1);
	glDeleteLists(pyramidTex, 1);
	glDeleteLists(floor0, 1);
	glDeleteLists(grid0, 1);
}

