//pet1.h
//l̉z
//{pO x

#define MAX_PARTS 20

//ẽ}eA
static float shadowDiffuse[] =  {0.0,0.0,0.0,0.3};//e̊gU
static float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

//display list
int sphere0, trunk0, head0, mouth0, leg0, tail0;

void createSphere0()
{
	sphere0 = glGenLists(1);
	if(sphere0 == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(sphere0, GL_COMPILE);
	drawSphere(0.5, 8, 8);
	glEndList();
}

void createTrunk0()
{
	trunk0 = glGenLists(1);
	if(trunk0 == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(trunk0, GL_COMPILE);
	drawSuper(0.5, 16, 8, 1.0, 0.5);
	glEndList();
}

void createHead0()
{
	head0 = glGenLists(1);
	if(head0 == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(head0, GL_COMPILE);
	drawSuper(0.5, 8, 8, 0.9, 0.8);
	glEndList();
}
void createMouth0()
{
	mouth0 = glGenLists(1);
	if(mouth0 == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(mouth0, GL_COMPILE);
	drawSuper(0.5, 8, 8, 0.5, 0.7);
	glEndList();
}

void createLeg0()
{
	leg0 = glGenLists(1);
	if(leg0 == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(leg0, GL_COMPILE);
	drawSuper(0.5, 8, 8, 1.0, 0.8);
	glEndList();
}
void createTail0()
{
	tail0 = glGenLists(1);
	if(tail0 == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(tail0, GL_COMPILE);
	drawSuper(0.5, 8, 8, 0.5, 0.8);
	glEndList();
}

void createDisplayListsPet()
{
	createSphere0();
	createTrunk0();
	createHead0();
	createMouth0();
	createLeg0();
	createTail0();
}
void deleteDisplayListsPet()
{
	glDeleteLists(sphere0, 1);
	glDeleteLists(trunk0, 1);
	glDeleteLists(head0, 1);
	glDeleteLists(mouth0, 1);
	glDeleteLists(leg0, 1);
	glDeleteLists(tail0, 1);
}

class CPet
{
public:
	CPet(void);
	~CPet(void) { };
	//oϐ
	int numParts;//p[c
	int numJoint;//֐ߌ

	float* diffuse ;//gU˗
	float* specular;//ʌ˗
	float* ambient; //˗
	float highlight;//
	bool flagShadow;

	//Root2̓̂̐ڑ_
  //pp
  //is
  float dir;
	//֐ߊp̔z
	CVector joint[MAX_PARTS];
	CVector pos[MAX_PARTS];//ep[c̒Sʒu(root̑Έʒuj
	//
	CVector trunk;//O2̓́iTCYj
	//
	CVector head ;
	//
	CVector neck;
  //
  CVector eye;
	//@
	CVector nose;
  //
  CVector ear;
	//S
	CVector mouth;
	//
	CVector mouthA;
	//riOrCr)
	CVector leg1, leg2;
  //
  CVector tail;
	//̕tʒu
	CVector tailPos;
  //rtʒu
	CVector legPos;//̒S̑Έʒu
  //ȓŜ̒
  float legLen;
	//Ŝ̃TCYiboxŋߎj
	float lngth, width, height;
	//animation
	float elapseTime;

	//o֐
	void draw(bool flagShadow);
  void reset();
	void walk(float dist, float step1, float tt, float dt);
  void turn(float angle, float tt);
	void stand(float tt);
	void initPose(float tt);
	void wait(float tt);
	void swingTail(int n, float tt);
	void upTail(float tt);
	void downTail(float tt);
//	void calcPosParts();
private:
  void drawTrunk();
  void drawHead(bool flagShadow);
  void drawLeg();
  void drawLeg1(int jNo);
  void drawLeg2(int jNo);
  void drawTail();
  void walkRight(float step1, float tt);
  void walkLeft(float step1, float tt);
};
//----------------------------------------------------------------
CPet::CPet()
{
	int i;

	static float diffuse0[] = {0.8f, 0.4f, 0.2f, 1.0f};
  static float ambient0[] = {0.6f, 0.3f, 0.1f, 1.0f};
	static float specular0[] = {0.7f, 0.6f, 0.6f, 1.0f};

	//z̃}eA
	diffuse = diffuse0;
  ambient = ambient0;
  specular = specular0;
  highlight = 100.0f;

	numParts = 13;
	numJoint = 11;
	//֐ߏl
	for(i = 0; i< numJoint; i++) joint[i] = CVector();
	//֐߂̏l
	joint[0].y = -90.0;
	//֐߂̏l
	joint[9].y = 30.0;
  //
	trunk = CVector( 1.0, 1.0, 1.0);
	//֐߂̈ʒu
	neck = CVector(trunk.x * 0.8, 0.0, trunk.z * 0.5 - 0.2);
	//
	head = CVector( 1.2, 1.2, 1.0) ;
  //
  eye = CVector( 0.2, 0.2, 0.2);
	//@
	nose = CVector( 0.15, 0.15, 0.15);
  //
  ear = CVector( 0.5, 0.15, 0.75);
	//S
	mouth = CVector(0.7, 0.7, 0.7) ;
	//
	mouthA = CVector(0.15, 0.2, 0.1);
	//riOrCr)
	leg1 = CVector(0.3, 0.3, 0.4);
	//riOrCr)
	leg2 = CVector(0.3, 0.3, 0.3);
  //
  tail = CVector( 0.4, 0.3, 0.3);
	tailPos = CVector(-trunk.x * 0.8, 0.0, trunk.z * 0.2);
  //rtʒu
	legPos.x = trunk.x/2.0 ;
  legPos.y = trunk.y/2.0 - 0.2;
  legPos.z = trunk.z/2.0 - 0.15;//̒S̋
  //rS
  legLen = leg1.y + leg2.y;
	//Ŝ̑傫iboxŋߎj
	lngth = 1.8 * trunk.x +( head.z + mouth.z) * 0.5;//x
	width = max(head.y, trunk.y);                    //y
	height = legLen + trunk.z + head.z * 0.9;        //z
}
//------------------------------------------------------------------
void CPet::draw(bool flagShadow)
{
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
		glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS,highlight);
	}
	else
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
		glMaterialf(GL_FRONT,GL_SHININESS,0.0);
	}

	glPushMatrix();
	glTranslatef(-0.3, 0.0, -0.25);//S_̒({pɑ΂ĂLj
  drawTrunk();//
  drawHead(flagShadow);//܂߂
  drawLeg();
  drawTail();
	glPopMatrix();
}
//------------------------------------------------------------------------------
void CPet::drawTrunk()
{
	//
	//Ôƌ㓷̂̒Ԃ
	glPushMatrix();//O
		glTranslatef(trunk.x * 0.4, 0.0, 0.0);
		glScalef(trunk.x, trunk.y, trunk.z);
		glCallList(trunk0);
	glPopMatrix();
	glPushMatrix();//㓷
		glTranslatef(- trunk.x * 0.4, 0.0, 0.0);
		glScalef(trunk.x, trunk.y, trunk.z);
		glCallList(trunk0);
	glPopMatrix();
}
//-----------------------------------------------------------------------------
void CPet::drawHead(bool flagShadow)
{
	static float diffuseEye[] = {0.1f, 0.1f, 0.4f, 1.0f};
	static float diffuseNose[] = {0.1f, 0.2f, 0.2f, 1.0f};
	static float diffuseMouth[] = {0.2f, 0.2f, 0.2f, 1.0f};

	glPushMatrix();

  //̈ʒu܂ŕsړ
	glTranslatef( neck.x , neck.y, neck.z );
  //]
  glRotatef(joint[0].z, 0.0, 0.0, 1.0);//z]
  glRotatef(joint[0].y , 0.0, 1.0, 0.0);//y]
  glRotatef(joint[0].x, 1.0, 0.0, 0.0);//x]

  glTranslatef(head.x / 2.0, 0.0, 0.0 );//̐[܂ŕsړ
  //
	glPushMatrix();
		glScalef(head.x, head.y, head.z);
		glCallList(head0);
	glPopMatrix();
	
	//ڂ̐F
	if(!flagShadow) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuseEye);
  //E
  glPushMatrix();
    glTranslatef(  head.x * 0.3, -head.y * 0.25, - head.z * 0.37 );
    glScalef(eye.x, eye.y, eye.z);
		glCallList(sphere0);
  glPopMatrix();
  //
  glPushMatrix();
    glTranslatef( head.x * 0.3, head.y * 0.25, - head.z * 0.37 );
    glScalef(eye.x, eye.y, eye.z);
		glCallList(sphere0);
  glPopMatrix();
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
		glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	}
  //E
  glPushMatrix();
    glTranslatef( head.x / 4.0, -head.y / 2.1, 0.0);//
    glRotatef(90.0 + joint[10].y, 0.0, 1.0, 0.0);//y]
    glScalef(ear.x, ear.y, ear.z);
    glTranslatef(0.0, 0.0, -0.5);
		glCallList(sphere0);
  glPopMatrix();
  //
  glPushMatrix();
    glTranslatef( head.x / 4.0, head.y / 2.1, 0.0);
    glRotatef(90.0 + joint[10].y, 0.0, 1.0, 0.0);//y]
    glScalef(ear.x, ear.y, ear.z);
    glTranslatef(0.0, 0.0, -0.5);
 		glCallList(sphere0);
  glPopMatrix();
	//S
	glPushMatrix();
    glTranslatef( 0.0, 0.0, -head.z / 2.0);
		glPushMatrix();
		glScalef(mouth.x, mouth.y, mouth.z);
		glCallList(mouth0);
		glPopMatrix();
		//@
		if(!flagShadow) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuseNose);
		glPushMatrix();
			glTranslatef(mouth.x * 0.15, 0.0, -mouth.z * 0.6);
			glScalef(nose.x, nose.y, nose.z);
			glCallList(sphere0);
		glPopMatrix();
		//
		if(!flagShadow) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuseMouth);
		glPushMatrix();
			glTranslatef(-mouth.x * 0.15, 0.0, -mouth.z * 0.5);
			glScalef(mouthA.x, mouthA.y, mouthA.z);
			glCallList(sphere0);
		glPopMatrix();	
	glPopMatrix();

  glPopMatrix();
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
		glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	}

}
//------------------------------------------------------------------
void CPet::drawLeg()
{
  //OEr
  glPushMatrix();
    // OEr̈ʒu֕sړ
    glTranslatef(legPos.x, -legPos.y, -legPos.z);
    drawLeg1(1);
    drawLeg2(5);
	glPopMatrix();
  //Or
  glPushMatrix();
    // Or̈ʒu֕sړ
    glTranslatef( legPos.x, legPos.y, -legPos.z);
    drawLeg1(2);
    drawLeg2(6);
  glPopMatrix();
  //Er
  glPushMatrix();
    // Er̈ʒu֕sړ
    glTranslatef(-legPos.x, -legPos.y, -legPos.z);
    drawLeg1(3);
    drawLeg2(7);
	glPopMatrix();
  //㍶r
  glPushMatrix();
    // ㍶r̈ʒu֕sړ
    glTranslatef( -legPos.x, legPos.y, -legPos.z);
    drawLeg1(4);
    drawLeg2(8);
	glPopMatrix();
}
//----------------------------------------------------------------------------
void CPet::drawLeg1(int jNo)
{
  //rt̉]
  glRotatef(joint[jNo].y, 0.0, 1.0, 0.0);//y]
  glRotatef(joint[jNo].x, 1.0, 0.0, 0.0);//x]
  glPushMatrix();
    glScalef(leg1.x, leg1.y + 0.01, leg1.z * 1.2 );
    glTranslatef(0.0, 0.0, -0.5);//_̈ʒu։
		glCallList(leg0);
  glPopMatrix();
}
//----------------------------------------------------------------------------
void CPet::drawLeg2(int jNo)
{
  //r̈ʒu֕sړ
  glTranslatef(0.0, 0.0, -leg1.z);
  //G̉]
  glRotatef(joint[jNo].y, 0.0, 1.0, 0.0);//y]
  glRotatef(joint[jNo].x, 1.0, 0.0, 0.0);//x]
  glPushMatrix();
    glScalef(leg2.x, leg2.y, leg2.z);
    glTranslatef(0.0, 0.0, -0.5);//_̈ʒu։
		glCallList(leg0);
  glPopMatrix();
}
//----------------------------------------------------------------------------
void CPet::drawTail()
{
  glPushMatrix();
    //̈ʒu֕sړ
    glTranslatef( tailPos.x, tailPos.y, tailPos.z);
    //̉]
    glRotatef(joint[9].z, 0.0, 0.0, 1.0);//z]
    glRotatef(joint[9].y, 0.0, 1.0, 0.0);//y]
    glRotatef(joint[9].x, 1.0, 0.0, 0.0);//x]
    glPushMatrix();
			glScalef(tail.x, tail.y, tail.z);
			glTranslatef(-0.5, 0.0, 0.0);
			glCallList(tail0);
    glPopMatrix();
	glPopMatrix();
}
