//surface.h
//tʂol-_̏ŴŌvZ

#define NX  20//10//xiq_
#define NY  20//10//yiq_
#define MAX_NUM    NX * NY//400//100
#define MAX_STRUCT (NX-1)*NY+NX*(NY-1)

struct Spring
{
  int row1, col1, row2, col2;
	float len;
};


struct Point
{
	CVector vSize;
	CVector vPos;
	CVector vAccel;
	CVector vForce;
	CVector vVelocity;
	float radius;
	float mass;
	bool flagFixed;
};

class CSurface
{
public:
  CVector vPos;  //Sʒu
  CVector vEuler;//XΊp
  float structK, structZ;
  float drag;///damping;
  int numRow;//s(xj
  int numCol;//(yj
  int numStruct; //ʏ̍\ol
  Spring structS[MAX_STRUCT];
  Point point[NX][NY];
  float lengthX0, lengthY0;//spring̊{
  float r0 ;//\ʗq̔a
  
  //o֐
  CSurface();
  void draw();
  void init();
	void newPointPos();
  void calcSpringMass25(float dt);
private:
};
//---------------------------------------------------------------
CSurface::CSurface()
{
	numRow = 10;
	numCol = 10;
	lengthX0 = 2.0;
	lengthY0 = 2.0;
  structK = 10.0;
	structZ = 1.0;
  drag = 1.0;

  //͂̑a
  for(int i = 0; i < numRow; i++)
    for(int j = 0; j < numCol; j++){
      point[i][j].vForce = CVector();
      point[i][j].vVelocity = CVector();
			point[i][j].flagFixed = false;
    }

}
CSurface surface;

//-----------------------------------------------------------------
void CSurface::draw()
{
  int i, j, np;
  float p[MAX_NUM][3]; //_W

  float diffuse[] = {0.8, 0.9, 1.0, 0.05};
  float specular[] = {1.0, 1.0, 1.0, 0.9};

	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuse);
	glMaterialfv(GL_FRONT,GL_SPECULAR, specular);
	glMaterialf(GL_FRONT,GL_SHININESS, 10.0);
	
	glPushMatrix();
  //݈ʒu
	glTranslatef(vesselB.vPos.x, vesselB.vPos.y, 0.0);//vesselB.vPos.z - vesselB.widthZ / 2.0);// + vesselB.heightFluid);//sړ

  //e_̍W
  for(j = 0; j < numCol; j++)
	{
    for(i = 0; i < numRow; i++)
		{
	    np = i * numCol + j;
	    p[np][0] = point[i][j].vPos.x;
	    p[np][1] = point[i][j].vPos.y;
	    p[np][2] = point[i][j].vPos.z;
    }
  }
  drawGridSquare(numRow, numCol, p);
	glPopMatrix();
}

//-----------------------------------------------------------------
void CSurface::init()
{
  int i, j, cnt;

  //_̃TCYCʒu(SIuWFNg̈ʒuƂj
  for(i = 0; i < numRow; i++)
	{
    for(j = 0; j < numCol; j++)
		{
			if(i == 0 || i == numRow-1) point[i][j].flagFixed = true;//eɐڐGĂ闱qx,yŒ
			if(j == 0 || j == numCol-1) point[i][j].flagFixed = true;//eɐڐGĂ闱qx,yŒ
			point[i][j].vForce = CVector();
			point[i][j].mass = 1.0;
//      point[i][j].vSize = CVector(2.0*r0, 2.0*r0, 2.0*r0);
      point[i][j].vSize = CVector(spaceCoord, spaceCoord, spaceCoord);
			point[i][j].vPos.x = ((float)i - (float)(numRow-1)/2.0) * lengthX0;
			point[i][j].vPos.y = ((float)j - (float)(numCol-1)/2.0) * lengthY0;
			point[i][j].vPos.z = vPos.z;//vesselB.heightFluid;
			//point[i][j].vPos += vPos;
			point[i][j].vVelocity = CVector();
    }
	}

  //olɐڑ闱qԍirow,colŎwj
  cnt = 0;
  for(i = 0; i < numRow; i++)
  {
    for(j = 0; j < numCol-1; j++)
    {
      structS[cnt].len = lengthY0;
      structS[cnt].row1 = i;
      structS[cnt].col1 = j;
      structS[cnt].row2 = i;
      structS[cnt].col2 = j + 1;
      cnt++;
    }
  }
  for(i = 0; i < numRow-1; i++)
  {
    for(j = 0; j < numCol; j++)
    {
      structS[cnt].len = lengthX0;
      structS[cnt].row1 = i;
      structS[cnt].col1 = j;
      structS[cnt].row2 = i + 1;
      structS[cnt].col2 = j;
      cnt++;
    }
  }
  numStruct = cnt;
}

//-----------------------------------------------------------------------------
//Q.5̃ol}Xf(RԂŉ^)
void CSurface::calcSpringMass25(float dt)
{                      
  int i, j, r1, r2, c1, c2;//, m;
  CVector vDir1;
  CVector vFF;
  CVector vRelativeVelocity;
  float len;
  CVector vNormal;

  //\olɂ
  for(i = 0; i < numStruct; i++)
	{
    //e
    r1 = structS[i].row1; c1 = structS[i].col1;
    r2 = structS[i].row2; c2 = structS[i].col2;
    vDir1 = point[r1][c1].vPos >> point[r2][c2].vPos;//#1#2ւ̒PʃxNg
    len = vDist(point[r1][c1].vPos, point[r2][c2].vPos);
    if(r1 == r2)//s̃ol
        vFF = (structK * (len - lengthY0)) * vDir1 ;
    else//̃ol
        vFF = (structK * (len - lengthX0)) * vDir1 ;
    point[r1][c1].vForce += vFF;//vDirƓ
    point[r2][c2].vForce -= vFF;//Ε
		//̂΂
		point[r1][c1].vForce -= structZ * (point[r1][c1].vPos - vPos).z * CVector(0.0, 0.0, 1.0);
		point[r2][c2].vForce -= structZ * (point[r2][c2].vPos - vPos).z * CVector(0.0, 0.0, 1.0);

    point[r1][c1].vForce -= drag * point[r1][c1].vVelocity;
    point[r2][c2].vForce -= drag * point[r2][c2].vVelocity;
  }
  //point̑xƈʒu̍XV(Euler@)
  for(i = 0; i < numRow; i++)
  {
		//sumHeight = 0.0;
    for(j = 0; j < numCol; j++)
    {
			if(!point[i][j].flagFixed) //free
			{
				//x
				point[i][j].vAccel = point[i][j].vForce / point[i][j].mass;
				//x
				point[i][j].vVelocity += point[i][j].vAccel * dt;
				//ʒu
				point[i][j].vPos += point[i][j].vVelocity * dt;
			}
			else//x,yW͗eɌŒ
			{//vesselɐڂĂtʗqzω
				point[i][j].vAccel.z = point[i][j].vForce.z / point[i][j].mass;
				//x
				point[i][j].vVelocity.z += point[i][j].vAccel.z * dt;
				//ʒu
				point[i][j].vPos.z += point[i][j].vVelocity.z * dt;
			}
    }
  }
}
