//vesselBox.h

struct SideB
{
	CVector vPos0;//vesselS̑Έʒui{p)
	CVector vPos;//vessel̕sړE]
	CVector vSize;
};

class CVesselBox
{
public:
	CVector vSize;//TCY
	CVector vPos;			//ʒu
	CVector vVelocity;//x
	CVector vVelocity0;//1secȎx
	CVector vAccel;   //x
	CVector vEuler;   //IC[p(p̏ݒ,deg)
	CVector vAxis;    //]
	CVector vAxis0;   //](ωO)
	CVector vAlpha;
	CVector vOmega;		//px
	float maxOmega;
	float angle;      //]px(rad)
	float accel, accelMax;//`x
	int mode;//샂[h
	CQuaternion q;
	int numSide;//ȇ
	SideB side[6];
	int farNo[6];
	float thickness;
	float widthX;
	float widthY;
	float widthZ;
	bool flagCover;
	bool flagStop;
	bool flagClose;
	float trans ;//x
	float heightFluid;
	bool flagSelect;
	//ފ֐
	CVesselBox();  //RXgN^
	~CVesselBox(); //fXgN^
	void draw(CVector eye, bool flagShadow);
	void CalcShadowMat(double* mat);
	void drawShadow(CVector eye);
	void ready();
private:
	void getFarNo(CVector eye);
};
CVesselBox vesselB;

CVesselBox::CVesselBox()
{
	thickness = 1.0;
	widthX = 25.0;
	widthY = 25.0;
	widthZ = 30.0;
	heightFluid = 20.0;//tʂ̍
	flagCover = true;
	trans = 0.7;//x
	numSide = 6;
	vVelocity = CVector();
	vAccel = CVector();
	vPos = CVector(0.0, 0.0, 35.0);
	vSize = CVector(widthX, widthY, widthZ);//1̃{bNXƂ݂ȂƂ̃TCY
	vEuler = CVector();
	q = CQuaternion();
}

void CVesselBox::ready()
{
	side[0].vPos0 = CVector(-widthX/2.0, 0.0, 0.0);//
	side[1].vPos0 = CVector(0.0, -widthY/2.0, 0.0);//
	side[2].vPos0 = CVector(0.0,  widthY/2.0, 0.0);//E
	side[3].vPos0 = CVector( widthX/2.0, 0.0, 0.0);//O
	side[4].vPos0 = CVector(0.0, 0.0, -widthZ/2.0);//
	side[5].vPos0 = CVector(0.0, 0.0,  widthZ/2.0);//(Wj
  side[0].vSize = CVector(thickness, widthY+thickness, widthZ);//
	side[1].vSize = CVector(widthX, thickness, widthZ);//
	side[2].vSize = CVector(widthX, thickness, widthZ);//E
	side[3].vSize = CVector(thickness, widthY+thickness, widthZ);//O
	side[4].vSize = CVector(widthX+thickness/2.0, widthY+thickness/2.0, thickness);//
	side[5].vSize = CVector(widthX+thickness/2.0, widthY+thickness/2.0, thickness);//(Wj
	vSize = CVector(widthX, widthY, widthZ);//1̃{bNXƂ݂ȂƂ̃TCY
	vAxis = vAxis0 = CVector();
	vAccel = CVector();
	vVelocity = CVector();
	vAlpha = CVector();
	vOmega = CVector();
	vEuler = CVector();
	q = CQuaternion();
	flagStop = true;
	mode = 0;//Î~
}

CVesselBox::~CVesselBox()
{
}

void CVesselBox::draw(CVector eye, bool flagShadow)
{
  float specular[]= { 0.8, 0.8, 0.8, 1.0};
	float diffuse[] = { 0.9, 0.5, 0.4, 1.0-trans};
	//ẽ}eA
	float shadowDiffuse[] =  {0.2, 0.1, 0.1, 0.3 * (1.0-trans)};//e̊gU

	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 80.0);
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuse);
	}
	else
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, shadowDiffuse);
	}

	getFarNo(eye);
	//int farNo[5];//_߂sideԍ

	glPushMatrix();
	//݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ
	//]
	if(q.s > 1.0) q.s = 1.0;
	if(q.s < -1.0) q.s = -1.0;
	float angle = 2.0 * acos(q.s);//[rad]
	CVector vAxis = q.v.norm2();
	glRotatef(angle * qq, vAxis.x, vAxis.y, vAxis.z);//]pdegɕϊ
	for(int i = 0; i < numSide; i++)
	{
		int k = farNo[i];
		glPushMatrix();
		glTranslatef(side[k].vPos0.x, side[k].vPos0.y, side[k].vPos0.z);
		//XP[O
		glScalef(side[k].vSize.x, side[k].vSize.y, side[k].vSize.z);
		//drawCube(1.0);
		glCallList(cube);
		glPopMatrix();
	}
	glPopMatrix();
}

void CVesselBox::CalcShadowMat(double* mat)
{
  double ex, ey, ez;//̕
  double a, b, c, d;//̖ʂ̃p[^
  double s; //objectS܂ł̋
  double x, y, z;

  x = lightPos[0] - vPos.x;
  y = lightPos[1] - vPos.y;
  z = lightPos[2] - vPos.z;

  //̕xNg
  s = sqrt(x * x + y * y + z * z);
  ex = x / s;
  ey = y / s;
  ez = z / s;

  //tA̕xNg(zj
  a = 0.0;
  b = 0.0;
  c = 1.0;
  d = -0.1; //tAƉe̊h
  //shadow matrix
  mat[0] = b * ey + c * ez;
  mat[1] = -a * ey;
  mat[2] = -a * ez;
  mat[3] = 0.0;
  mat[4] = -b * ex;
  mat[5] = a * ex + c * ez;
  mat[6] = -b * ez;
  mat[7] = 0.0;
  mat[8] = -c * ex;
  mat[9] = -c * ey;
  mat[10] = a * ex + b * ey;
  mat[11] = 0.0;
  mat[12] = -d * ex;
  mat[13] = -d * ey;
  mat[14] = -d * ez;
  mat[15] = a * ex + b * ey + c * ez;
}

void CVesselBox::drawShadow(CVector eye)
{
  //vZ͕sɑ΂e
  //޼ުĂƂɌ̕ςA^Iɓ_ɑ΂e
  double mat[16]; //es̗vf

  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

  glDepthMask(GL_FALSE);
	{
			CalcShadowMat(mat);
			glPushMatrix();
				glMultMatrixd(mat);//}gNX̏Z
				draw(eye, true);//޼ުĂ̕`
			glPopMatrix();
	}

  //e̕`I
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
}

void CVesselBox::getFarNo(CVector eye)
{
	int i, j;
	float farthest;

	float dist[6];
	int mark[6];//ς݂1Ƃ

	for(i = 0; i < numSide; i++)
	{
		side[i].vPos = qvRotate(q, side[i].vPos0) + vPos;
		dist[i] = vDist(side[i].vPos, eye);
		mark[i] = 0;
	}
	for(i = 0; i < numSide; i++)
	{
		farthest = 0.0;//dist[i];
		for(j = 0 ; j < numSide; j++)
		{
			if(mark[j] == 1) continue;//mς
			if(farthest < dist[j])
			{
				farNo[i] = j;
				farthest = dist[j];
			}
		}
		mark[farNo[i]] = 1;
	}
//for(i = 0; i < numSide; i++) printf("i = %d, farNo = %d, dist = %f \n", i, farNo[i], dist[i]);
}


