/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

}OiXʂꂽ^
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../rigid3D.h"
#include "../../setup.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();
void initObject();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2;
//VF[_vO
GLuint shaderProg;

int massIndex = 5;
float mass0 = 0.145;//KgP
float velY0 = 80.0;//[Km/h]
float velZ0 = 0.0; //[Km/h]
float revX0 = 1000.0;//[rpm]
float revZ0 = 800.0;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_Magnus");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");
	
  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.3, 0.3, 0.32, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 50.0;
	view.vCnt = CVector(0.0, 0.0, 2.0);
	view.theta = 0.0;
	view.phi = 90.0;
	setCamera();
	view0 = view;
	//flag
	flagDrag = true;
	flagMagnus = true;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //init()̑oߎ

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
  setTexture();
  
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	createDisplayListsPet();
	createDisplayListsVehicle();
	initObject();

	//L[̐
	printf("L[ɂÎ̕sړ(t)E](r)Eʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[d]key:CRL^̐؂ւ \n");
	printf("[m]key:}OiXʗL^̐؂ւ \n");
	printf("[i]key:]̍W(/޼ުĎj̕ύX \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[a]key:e\/\؂ւ \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[T]key:gbN[h؂ւ \n");
	printf("[S]key:Xg{\/\؂ւ \n");
	printf("[F]key:tA\/\؂ւ \n");
	printf("[F1]key:CW̑ \n");
	printf("[F2]key:W̑ \n");
	printf("[F3]key:ʂ̑ \n");
	printf("[F4]key:yx̑ \n");
	printf("[F5]key:zx̑ \n");
	printf("[F6]key:xpx̑ \n");
	printf("[F7]key:zpx̑ \n");
}

void initObject()
{
	flagStart = false;
	flagStrobo = false;
	countStrobo = 0;
	timeStrobo = 0.0;
	periodStrobo = 0.2;
	timeRate = 0.5;

//	ci = 0.0;//RW

	//̂̏ݒ
	numRigid0 = 1;
	numStrobo = 100;
	numRigid = numRigid0 + numStrobo;//100̓Xg{p
	selNo = 0;
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	rigid[0].mass = mass0;
	rigid[0].vPos = CVector(0.0, -15.0, 10.0);
	rigid[0].vSize = CVector(0.74, 0.74, 0.74);
	rigid[0].vVelocity = CVector(0.0, velY0, velZ0) * 1000.0 / 3600;//[Km/h]->[m/s]ɕϊ
	rigid[0].vOmega = CVector(revX0, 0.0, revZ0) * 2.0 * M_PI / 60.0;//[rpm]->[rad/s]
	rigid[0].ready();

	for(i = numRigid0; i < numRigid; i++) {
		rigid[i].vSize = CVector(0.3, 0.3, 0.3);
		rigid[i].color = CYAN;
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}
}

void setTexture()
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	for(int i = 0; i < numRigid; i++)
	{
		if(i == selNo)
		{
			glUniform1i(selLoc, 1);
			rigid[i].select = true;
		}
		else
		{
			glUniform1i(selLoc, 0);
			rigid[i].select = false;
		}
		if(flagStrobo) rigid[i].draw(false);
		else rigid[0].draw(false);
	}

  glUseProgram(0);

	if(flagStart == true && flagFreeze == false) 
	{
	  rigid[0].action3D(timeRate * dt);//^͒ڍ̂
		if(flagOneStep) flagFreeze = true;
		
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) rigid[numRigid0 + countStrobo].vPos = rigid[0].vPos;

			timeStrobo += dt;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
		}
	}

	if(flagFloor) glCallList(floor0);//En
  if(flagShadow) drawShadow();     //e
	if(flagCoord) 
	{
		drawWorldCoordinates(2.0); //[hԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("muK=%3.2f", muK, 190, 30);
		drawParam("e=%3.2f", e, 320, 30);
		drawParam("mass=%3.3f[Kg]", mass0, 450, 30);
		drawParam("velY0=%3.1f[Km/h]", velY0, 10, 60);
		drawParam("velZ0=%3.1f[Km/h]", velZ0, 170, 60);
		drawParam("revX0=%3.1f[rpm]", revX0, 320, 60);
		drawParam("revZ0=%3.1f[rpm]", revZ0, 480, 60);
	}

	if(flagTrack)//ɃR[fBOƕ\Ȃ
	{
		view.vCnt.x = rigid[selNo].vPos.x;
		view.vCnt.y = rigid[selNo].vPos.y;
		setCamera();
	}
	//obt@̐؂ւ
  glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
		for(int i = 0; i < 3; i++)lightPos[i] = lightPos0[i];
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'd':
		flagDrag = !flagDrag;
		if(flagDrag) printf("flagDrag = true \n");
		else printf("flagDrag = false\n");
		break; 
	case 'm':
		flagMagnus = !flagMagnus;
		if(flagMagnus) printf("flagMagnus = true \n");
		else printf("flagMagnus = false\n");
		break; 
	case 't':
		shiftMode = TRANSLATE;
		break;
	case 'r':
		shiftMode = ROTATION;
		break;
	case 'l':
		shiftMode = LIGHT;
		break;
	case 'i':
		if(coordMode == INERTIAL) coordMode = OBJECT;
		else coordMode = INERTIAL;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'a':
		flagShadow = !flagShadow;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'T':
		flagTrack = !flagTrack;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(shiftMode == TRANSLATE)
	{
		//Î̕sړ
		float d = 0.1;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			rigid[selNo].vPos.y += d;
			break;
		case GLUT_KEY_LEFT://-y
			rigid[selNo].vPos.y -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) rigid[selNo].vPos.x -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) rigid[selNo].vPos.z += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) rigid[selNo].vPos.x += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) rigid[selNo].vPos.z -= d;//-z
			break;
		default:
			break;
		}
	}

	else if(shiftMode == ROTATION && coordMode == INERTIAL)
	{
		//Î̊Ԃɂ]
		float theta = 5.0;//[deg];

		switch( key )
		{
		case GLUT_KEY_RIGHT://y]
			rigid[selNo].q = getQFromAxis(theta, CVector(0.0, 1.0, 0.0)) * rigid[selNo].q;
			break;
		case GLUT_KEY_LEFT://-y]
			rigid[selNo].q = getQFromAxis(theta, CVector(0.0, -1.0, 0.0)) * rigid[selNo].q;
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) //-x]
				rigid[selNo].q = getQFromAxis(theta, CVector(-1.0, 0.0, 0.0)) * rigid[selNo].q;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) //z]
				rigid[selNo].q = getQFromAxis(theta, CVector(0.0, 0.0, 1.0)) * rigid[selNo].q;
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0)//x]
				rigid[selNo].q = getQFromAxis(theta, CVector(1.0, 0.0, 0.0)) * rigid[selNo].q;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)//-z]
				rigid[selNo].q = getQFromAxis(theta, CVector(0.0, 0.0, -1.0)) * rigid[selNo].q;
			break;
		default:
			break;
		}
	}

	else if(shiftMode == ROTATION && coordMode == OBJECT)
	{
		//Î̃IuWFNgԂɂ]
		float theta = 5.0;//[deg];
		switch( key )
		{
		case GLUT_KEY_RIGHT://y]
			rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, 1.0, 0.0)) ;
			break;
		case GLUT_KEY_LEFT://-y]
			rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, -1.0, 0.0));
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) //-x]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(-1.0, 0.0, 0.0));
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) //z]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, 0.0, 1.0));
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0)//x]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(1.0, 0.0, 0.0));
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)//-z]
				rigid[selNo].q = rigid[selNo].q * getQFromAxis(theta, CVector(0.0, 0.0, -1.0));
			break;
		default:
			break;
		}
	}

	else if(shiftMode == LIGHT)
	{
		//Î̕sړ
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			lightPos[1] += d;
			break;
		case GLUT_KEY_LEFT://-y
			lightPos[1] -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) lightPos[0] -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) lightPos[0] += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//-z
			break;
		default:
			break;
		}
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) muK += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) muK -= 0.05;
		if(muK > 1.0) muK = 1.0;
		if(muK < 0.0) muK = 0.0;
		initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) e += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) e -= 0.05;
		if(e > 1.0) e = 1.0;
		if(e < 0.0) e = 0.0;
		initObject();
	}
	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) massIndex += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) massIndex -= 1;
		if(massIndex > 7) massIndex = 7;
		if(massIndex < 0) massIndex = 0;
		if(massIndex == 0) mass0 = 0.001;//0.002ȉł͉]̌[`ŃG[ɂȂ邱Ƃ
		else if(massIndex == 1) mass0 = 0.005;
		else if(massIndex == 2) mass0 = 0.01;
		else if(massIndex == 3) mass0 = 0.05;
		else if(massIndex == 4) mass0 = 0.1;
		else if(massIndex == 5) mass0 = 0.145;//d싅{[
		else if(massIndex == 6) mass0 = 0.5;
		else if(massIndex == 7) mass0 = 1.0;
		initObject();
	}
	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) velY0 += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) velY0 -= 10.0;
		if(velY0 < 1.0) velY0 = 0.0;
		initObject();
	}
	if(key == GLUT_KEY_F5) 
	{
		if(glutGetModifiers() == 0) velZ0 += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) velZ0 -= 10.0;
		if(velZ0 < 1.0) velZ0 = 0.0;
		initObject();
	}
	if(key == GLUT_KEY_F6) 
	{
		if(glutGetModifiers() == 0) revX0 += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) revX0 -= 10.0;
		initObject();
	}
	if(key == GLUT_KEY_F7) 
	{
		if(glutGetModifiers() == 0) revZ0 += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) revZ0 -= 10.0;
		initObject();
	}
}

