/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

3D many body animation
̓m̖CRlȂitAゾj
ȊOɂƂ݂ȂՓ˔
Wlrɂ\𗘗p
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "rigid.h"
#include "collision.h"
#include "../../setup.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void mouse(int button, int state, int x, int y);
void special(int key, int x, int y);
void motion(int x, int y);
void initObject();
void drawSprite();

//摜f[^̃TCY
int imgWidth, imgHeight;
//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;
double timeStep;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_Collision3D4");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 100.0;
	view.vCnt = CVector(0.0, 0.0, 30.0);
	view.theta = 30.0;
	view.phi = 0.0;
	view.nearZ = 10.0;
	view.farZ = 2000.0;
	setCamera();
	view0 = view;
	//q
	numRigid = 1000;
	//Փˊ֌W̏l
	e = 0.1;
	muK = 0.1;
	cSpring = 200.0;
	timeRate = 1.0;//X[[VW
	spaceCoord = 1.0;//
	shiftMode = LIGHT;//Wlr̊Ԋu
  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0; //1secԈȓ̌oߎ
  elapseTime2 = 0.0; //start̑oߎ

  setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("L[ɂ̕sړ \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[a]key:e\/\؂ւ \n");
	printf("[p]key:Ұ\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[C]key:ՓˏL/̐؂ւ \n");
	printf("[F]key:tA\/\؂ւ \n");
	printf("[F1]key:̐̑ \n");
	printf("[F2]key:CW̑ \n");
	printf("[F3]key:W̑ \n");
	printf("[F4]key:グ͂̑ \n");
	printf("[F5]key:S͌W̑ \n");
}

void initObject()
{
	//V~[V
	//̂̏ݒ
	int nn = numRigid;
	int i;
	for(i = 0; i < nn; i++) 
	{
		rigid[i].vSize = CVector(spaceCoord, spaceCoord, spaceCoord);
		rigid[i].vPos = CVector(getRandom(-40.0, 40.0), getRandom(-40.0, 40.0), rigid[i].vSize.z / 2.0);
		rigid[i].vOmega = CVector(getRandom(-1.0, 1.0), getRandom(-1.0, 1.0), getRandom(-1.0, 1.0));
	}
	for(i = 0; i < nn/4;i++)
	{ 
		rigid[i].color = YELLOW;
		rigid[i].kind = CUBE;
	}
	for(i = nn/4; i < nn/2;i++) 
	{
		rigid[i].color = BLUE;
		rigid[i].kind = SPHERE;
	}
	for(i = nn/2; i < 3*nn/4; i++) 
	{
		rigid[i].color = RED; 
		rigid[i].kind = TORUS; 
	}
	for(i = 3*nn/4; i < nn; i++) 
	{
		rigid[i].color = GREEN; 
		rigid[i].kind = CYLINDER;
	}

	flagStart = false;
}


void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
		//glLineWidth(1.0);
  }
	else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);

	for(int i = 0; i < numRigid; i++) rigid[i].draw(false);

	glUseProgram(0);

	if(flagFloor) glCallList(floor0);//En
  if(flagShadow) drawShadow();     //e
	if(flagCoord) drawWorldCoordinates(2.0);

	timeStep = timeRate * dt;

	if(flagStart==true && flagFreeze == false) 
	{
	  collision(timeStep);//Փ˔(collision.h)
	}

	if(flagParamShow) 
	{
		drawParam("frame rate=%d[fps]", fps0, 10, 30);
		drawParam("num=%d", numRigid, 200, 30);
		drawParam("muK=%3.2f", muK, 320, 30);
		drawParam("e=%3.2f", e, 460, 30);
		drawParam("forceZ=%3.2f", forceZ, 10, 60);
		drawParam("central=%3.2f", central, 200, 60);
	}

	//I
  glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(flagStart) elapseTime2 = 0.0;
		else initObject();
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'a':
		flagShadow = !flagShadow;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'W':
		flagWall = !flagWall;
		break;
	case 'C':
		flagCollision = !flagCollision;
		if(flagCollision) printf("ՓˏL\n");
		else printf("Փˏ\n");
		break;
	case 'x':
//		flagColor = !flagColor;
		break;
  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(shiftMode == LIGHT)
	{
		//Î̕sړ
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			lightPos[1] += d;
			break;
		case GLUT_KEY_LEFT://-y
			lightPos[1] -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) lightPos[0] -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) lightPos[0] += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//-z
			break;
		default:
			break;
		}
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) numRigid += 100;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) numRigid -= 100;
		if(numRigid < 100) numRigid = 100;
		if(numRigid > 2000) numRigid = 2000;
		initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) muK += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) muK -= 0.05;
		if(muK > 1.0) muK = 1.0;
		if(muK < 0.0) muK = 0.0;
	}
	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) e += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) e -= 0.05;
		if(e > 1.0) e = 1.0;
		if(e < 0.0) e = 0.0;
	}

	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) forceZ += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) forceZ -= 1.0;
		if(forceZ < 0.0) forceZ = 0.0;
	}
	if(key == GLUT_KEY_F5) 
	{
		if(glutGetModifiers() == 0) central += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) central -= 0.1;
		if(central < 0.0) central = 0.0;
	}

}

