/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg


e̗qɑ΂ĔSRC͂l
̗e
Wlrɂ\𗘗p
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../parametersVessel.h"
#include "rigid.h"
#include "collision.h"
#include "../../setupVessel.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void mouse(int button, int state, int x, int y);
void special(int key, int x, int y);
void motion(int x, int y);
void initObject();

//摜f[^̃TCY
int imgWidth, imgHeight;
//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;

//VF[_vO
GLuint shaderProg;
double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_Buoyant");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 150.0;
	view.vCnt = CVector(0.0, 0.0, 40.0);
	view.theta = 20.0;
	view.phi = 0.0;
	view.nearZ = 10.0;
	view.farZ = 2000.0;
	setCamera();
	view0 = view;
	//q
	numRigid = 500;
	//Փˊ֌W̏l
	e = 0.1;
	buoyant = 11.76;//9.8;
	cSpring = 50.0;
	timeRate = 1.0;//X[[VW
	spaceCoord = 2.0;
	shiftMode = LIGHT;
  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //start̑oߎ

  setFontBitmaps();

	//display list쐬
	createDisplayLists();

	initObject();

	//L[̐
	printf("L[ɂʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[a]key:e\/\؂ւ \n");
	printf("[p]key:Ұ\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[C]key:e̊W̊J؂ւ \n");
	printf("[F]key:tA\/\؂ւ \n");
	printf("[F1]key:̐̑ \n");
	printf("[F2]key:W̑ \n");
	printf("[F3]key:SW̑ \n");
	printf("[F4]key:͂̑ \n");
	printf("[F5]key:ol萔̑ \n");
	printf("[F6]key:x̑ \n");
}

void initObject()
{
	//e쐬
	vesselB.widthY = 40.0;
	vesselB.heightFluid = 20.0;
	vesselB.flagClose = true;
	vesselB.flagCover = true;
	vesselB.ready();
	//t
	surface.numRow = 10;
	surface.numCol = 10;
  surface.lengthX0 = vesselB.widthX / (float)(surface.numRow-1);
  surface.lengthY0 = vesselB.widthY / (float)(surface.numCol-1);
  surface.structK = 10.0;//500.0;
	surface.structZ = 1.0;
  surface.drag = 0.1;

	surface.vPos = vesselB.vPos;
	surface.vPos.z = vesselB.vPos.z - vesselB.widthZ / 2.0 + vesselB.heightFluid;//tʂ̍
	surface.init();

	//̂̏ݒ
	int i;
	for(i = 0; i < numRigid; i++) 
	{
		rigid[i].kind = SPHERE;
		rigid[i].vSize = CVector(spaceCoord, spaceCoord, spaceCoord);//TCY͌Œ
		rigid[i].color = CYAN;
		rigid[i].vPos.x = getRandom(-vesselB.widthX/2+2.0, vesselB.widthX/2.0-2.0);
		rigid[i].vPos.y = getRandom(-vesselB.widthY/2+2.0, vesselB.widthY/2.0-2.0);
		rigid[i].vPos.z = getRandom(-vesselB.widthZ/2.0+2.0, vesselB.widthZ/2.0-10.0) + vesselB.vPos.z;
		rigid[i].flagOut = false;
		rigid[i].vVelocity = CVector(getRandom(-1.0, 1.0), getRandom(-1.0, 1.0), 0.0);
		if(i < numRigid / 3)
		{
			rigid[i].mass = 1.0;
			rigid[i].color = CYAN;
		}
		else if( i < 2 * numRigid / 3)
		{
			rigid[i].mass = 1.2;
			rigid[i].color = YELLOW;
		}
		else 
		{
			rigid[i].mass = 1.4;
			rigid[i].color = GREEN;
		}
	}

	flagStart = false;
}


void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	float dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
		//glLineWidth(1.0);
  }
	else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);

	//̂Ƃ
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	//rigid
	for(int i = 0; i < numRigid; i++) rigid[i].draw(false); 
	if(flagFloor) glCallList(floor0);//En
  if(flagShadow)
	{//e
		drawShadow();     
		vesselB.drawShadow(view.vPos);
	}

	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//t
	surface.draw();
	//vessel
	vesselB.draw(view.vPos, false);
	
	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);

	glUseProgram(0);

	if(flagCoord) drawWorldCoordinates(20.0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ
	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
	  collision(timeStep);//Փ˔(collision.h)		
		surface.calcSpringMass25(timeStep);//surface.h
	}

	if(flagParamShow) 
	{
		drawParam("frame rate=%d[fps]", fps0, 10, 30);
		drawParam("num=%d", numRigid, 190, 30);
		drawParam("e=%3.2f", e, 290, 30);
		drawParam("viscous=%3.2f", viscous, 370, 30);
		drawParam("cSpring=%3.1f", cSpring, 490, 30);
		drawParam("buoyant=%3.2f", buoyant, 10, 60);
		drawParam("trans=%3.2f", vesselB.trans, 150, 60);
	}

	//I
  glutSwapBuffers();
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(flagStart) elapseTime2 = 0.0;
		else initObject();
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		break;
		case 't':
		shiftMode = TRANSLATE;
		break;
	case 'r':
		shiftMode = ROTATION;
		break;
	case 'l':
		shiftMode = LIGHT;
		break;

  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'a':
		flagShadow = !flagShadow;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'C':
		vesselB.flagCover = !vesselB.flagCover;
		if(vesselB.flagCover) vesselB.numSide = 6;
		else vesselB.numSide = 5;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(shiftMode == LIGHT)
	{
		//̕sړ
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			lightPos[1] += d;
			break;
		case GLUT_KEY_LEFT://-y
			lightPos[1] -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) lightPos[0] -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) lightPos[0] += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//-z
			break;
		default:
			break;
		}
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) numRigid += 10;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) numRigid -= 10;
		if(numRigid < 10) numRigid = 10;
		if(numRigid > 1000) numRigid = 1000;
		initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) e += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) e -= 0.05;
		if(e > 1.0) e = 1.0;
		if(e < 0.0) e = 0.0;
	}

	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) viscous += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) viscous -= 0.05;
		if(viscous > 1.0) viscous = 1.0;
		if(viscous < 0.0) viscous = 0.0;
	}

	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) cSpring += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) cSpring -= 10.0;
		if(cSpring < 0.0) cSpring = 0.0;
	}

	if(key == GLUT_KEY_F5) 
	{
		if(glutGetModifiers() == 0) buoyant += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) buoyant -= 0.01;
		if(buoyant < 0.0) buoyant = 0.0;
	}

	if(key == GLUT_KEY_F6) 
	{
		if(glutGetModifiers() == 0) vesselB.trans += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) vesselB.trans -= 0.1;
		if(vesselB.trans < 0.0) vesselB.trans = 0.0;
		if(vesselB.trans > 1.0) vesselB.trans = 1.0;
	}
}

