/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

fn`V~[V
ׂĂ̘f͑z̈͂󂯂D
fǂ͋߂̂Ɉ͂^D
Փ˂Ƃ͍
*/

#define FILENAME_IN_0 "../../bmp/sun2.bmp"
#define FILENAME_IN_1 "../../bmp/moon1.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../rigidSolar.h"
#include "../../setupSolar.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture(int n);
void initObject();
bool collision(int i, int j, float d);

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLuint texName[2];

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

float GM = 10000.0;
float G_CONST = 0.001;//L͒萔
float MASS = GM / G_CONST;
float distEffect = 15.0;//͂̉e󂯂鋗
float constMR = 0.06;//->aϊ̔萔

double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_PlanetaryCreation");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shadingS.frag");
	
  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.11, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 250.0;//80.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 80.0;
	view.phi = 0.0;
	setCamera();
	view.nearZ = 10.0;
	view.farZ = 1000.0;
	view0 = view;
	//
	lightPos[2] = 50.0;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

	//eNX`[
  glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_0);
  setTexture(0);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_1);
  setTexture(1);
 
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("L[ɂʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[S]key:Xg{\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
	printf("[F1]key:GMς̑ \n");
	printf("[F2]key:ʂ̏dɕבւ \n");
}

void initObject()
{
	flagStart = false;
	flagStrobo = false;
	countStrobo = 0;
	timeStrobo = 0.0;
	periodStrobo = 0.1;//0.2;
	timeRate = 1.0;

	MASS = GM / G_CONST;//z

	constMR = 0.06;//->aϊ̔萔(̒l傫Ɛcf͏ȂȂj

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ

	//̂̏ݒ
	numPlanet = 200;
	numRigid0 = numPlanet + 1;//1͑z
	numStrobo = 100;
	numRigid = numRigid0 + numStrobo;//100̓Xg{p
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	float dia;

	//ziSɌŒj
	rigid[0].mass = MASS;
	dia = 2.0 * constMR * pow((double)rigid[0].mass, 0.333);
	rigid[0].vSize = CVector(dia, dia, dia);
	rigid[0].vPos = CVector(0.0, 0.0, 0.0);
	rigid[0].vOmega = CVector(0.0, sin(7.15 * pp), cos(7.15 * pp));//K
	rigid[0].vEuler = CVector(-7.15, 0.0, 0.0);
	rigid[0].q = getQFromEulerXYZ(rigid[0].vEuler) * rigid[0].q;

//	srand(0);
	CVector vTan;
	for(i = 1; i < numRigid0; i++)
	{
		rigid[i].mass = getRandom(0.1, 1.0) * MASS / 1000.0;
		dia = 2.0 * constMR * pow((double)rigid[i].mass, 0.333);
		rigid[i].vSize = CVector(dia, dia, dia);
		if(rigid[i].mass > 700.0) rigid[i].color = CYAN;
		else if(rigid[i].mass > 400.0) rigid[i].color = YELLOW;
		else rigid[i].color = MAGENTA;
		rigid[i].vPos = getRandomRingVectorXY(20.0, 100.0);
		vTan = vCross(CVector(0.0, 0.0, 1.0), rigid[i].vPos).norm2();//ڐ
		double r = rigid[i].vPos.magnitudeXY();
		rigid[i].vVelocity = vTan * (sqrt((double)(GM) / r));
		float ang = getRandom(5.0, 30.0);//XΊp
		rigid[i].vOmega = CVector(0.0, sin(ang * pp), cos(ang * pp)) * getRandom(0.5, 2.0);//K
		rigid[i].vEuler = CVector(-ang, 0.0, 0.0);
		rigid[i].q = getQFromEulerXYZ(rigid[0].vEuler) * rigid[i].q;
	}
	for(i = 0; i < numRigid0; i++)	rigid[i].ready();

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		if(((i-numRigid0) / 2) * 2 == i - numRigid0) 
		{
			rigid[i].color = WHITE;
			rigid[i].vSize = CVector(1.0, 1.0, 1.0);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
		else
		{
			rigid[i].color = CYAN;
			rigid[i].vSize = CVector(1.0, 1.0, 1.0);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
	}
}

void setTexture(int n)
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
   //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[n]);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
//  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;

if((int)elapseTime2 == 0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 10.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 20.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 30.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 50.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 70.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 100.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 150.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 200.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 300.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 500.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 700.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 1000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 2000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 3000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 5000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//1.39
if((int)elapseTime2 == 10000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//2.78
if((int)elapseTime2 == 20000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 50000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//13.89
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	//texture unit  texture object ̊֘At
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  //`
  // VF[_vO̓Kp 
	glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	GLint sunLoc = glGetUniformLocation(shaderProg, "sun");
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	glUniform1i(selLoc, 1);

	for(int i = 0; i < numRigid0; i++) 
	if(rigid[i].vanish == 0) 
	{
		rigid[i].select = true;
		if(i == 0){
			glUniform1i(sunLoc, 1);
			glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
		}
		else {
			glUniform1i(sunLoc, 0);
			glUniform1i(imageLoc, 1);//GL_TEXTUREiKp
		}
		rigid[i].draw();
	}
		
	if(flagStrobo)
	{
		for(int i = numRigid0; i < numRigid; i++)
		{
			glUniform1i(selLoc, 0);
			rigid[i].draw();
		}
	}

  glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
	  elapseTime2 += dt;

		rigid[0].attraction(dt * timeRate);//z͎]
		numPlanet = 0;//c葍
		for(int i = 1; i < numRigid0; i++)
		{
			if(rigid[i].vanish == 1) continue;
			numPlanet ++;
			rigid[i].vAccel = CVector();

			for(int j = 0; j < numRigid0; j++)
			{
				if(j == i) continue;
				if(rigid[j].vanish == 1) continue;
				
				float d = vDist(rigid[i].vPos, rigid[j].vPos);
				if(j >= 1 && d > distEffect) continue;//RgɂƑSfΏ
				if(!collision(i, j, d))//fԈ
					rigid[i].vAccel += (rigid[i].vPos >> rigid[j].vPos) * G_CONST * rigid[j].mass / (d * d);
			}
			rigid[i].attraction(timeStep);//^͘f
		}

		if(flagOneStep) flagFreeze = true;

		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
					if((countStrobo/2) * 2 == countStrobo) rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
					else                                   rigid[numRigid0 + countStrobo].vPos = rigid[2].vPos;
			}

			timeStrobo += dt;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
		}
	}

	glDisable(GL_LIGHTING);
	if(flagFloor) glCallList(grid0);//iq
	glEnable(GL_LIGHTING);
	if(flagCoord) 
	{
		drawWorldCoordinates(15.0); //[hԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("elapseTime2=%d[s]", (int)elapseTime2, 200, 30);
		drawParam("numPlanet=%d", numPlanet, 400, 30);
		drawParam("GM=%3.1f", GM, 20, 60);
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}

bool collision(int i, int j, float dist)
{
	float dia;

	float a = (rigid[i].vSize.x + rigid[j].vSize.x)/2.0;
	if(dist > a) return false;
	//ʂ̏
	if(rigid[i].mass >= rigid[j].mass) 
	{
		if(j != 0)//zȊO
		{
			rigid[j].vanish = 1;
		}
		if(i != 0) 
		{
			rigid[i].vVelocity = (rigid[i].mass * rigid[i].vVelocity + rigid[j].mass * rigid[j].vVelocity) / (rigid[i].mass + rigid[j].mass);
			rigid[i].mass += rigid[j].mass;
			rigid[j].mass = 0.0;
			dia = 2.0 * constMR * pow((double)rigid[i].mass, 0.333);
			rigid[i].vSize = CVector(dia, dia, dia);
		}
	}
	else
	{
		if(i != 0)
		{
			rigid[i].vanish = 1;
		}
		if(j != 0) 
		{
			rigid[j].vVelocity = (rigid[i].mass * rigid[i].vVelocity + rigid[j].mass * rigid[j].vVelocity) / (rigid[i].mass + rigid[j].mass);
			rigid[j].mass += rigid[i].mass;
			rigid[i].mass = 0.0;
			dia = 2.0 * constMR * pow((double)rigid[j].mass, 0.333);
			rigid[j].vSize = CVector(dia, dia, dia);
		}
	}
	return true;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'i':
		if(coordMode == INERTIAL) coordMode = OBJECT;
		else coordMode = INERTIAL;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'T':
		flagTrack = !flagTrack;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) GM += 100.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) GM -= 100.0;
		if(GM < 100) GM = 100.0;
		
		initObject();
	}
	
	float mass;
	Color col;
	CVector pos, vel, size;
	int vanish;
	if(key == GLUT_KEY_F2)
	{
		flagFreeze = true;
		for(int k = 1; k < 3; k++)
		{
			for(int i = k+1; i < numRigid0;i++)
			{
			  if(rigid[i].vanish == 1) continue;
				if(rigid[i].mass > rigid[k].mass) 
				{
					mass = rigid[k].mass;
					col = rigid[k].color;
					pos = rigid[k].vPos;
					vel = rigid[k].vVelocity;
					size = rigid[k].vSize;
					vanish = rigid[k].vanish;
					rigid[k].mass = rigid[i].mass;
					rigid[k].color = rigid[i].color ;
					rigid[k].vPos = rigid[i].vPos;
					rigid[k].vVelocity = rigid[i].vVelocity;
					rigid[k].vSize = rigid[i].vSize;
					rigid[k].vanish = rigid[i].vanish;

					rigid[i].mass = mass;
					rigid[i].color = col ;
					rigid[i].vPos = pos;
					rigid[i].vVelocity = vel;
					rigid[i].vSize = size;
					rigid[i].vanish = vanish;		
				}
			}
		}
		flagFreeze = false;
printf("1  x=%f, y=%f \n", rigid[1].vPos.x, rigid[1].vPos.y);
printf("2  x=%f, y=%f \n", rigid[2].vPos.x, rigid[2].vPos.y);
printf("mass1=%f, mass2=%f \n", rigid[1].mass, rigid[2].mass);
	}
}

