/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

͂ɂ2̖
zƘf邢͘fƉq̊֌W
ΈʒuxNggpȂ
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN_0 "../../bmp/earth1.bmp"
#define FILENAME_IN_1 "../../bmp/sun0.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../rigidSolar.h"
#include "../../collisionSolar.h"
#include "../../setupSolar.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture(int n);
void initObject();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLuint texName[2];

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

float GM = 2000.0;
float radius0 = 20.0;//[m]̋Oa
float speed0 = 0.5 * sqrt(GM / radius0);//[m/s]ڐ̑xl
float massRatio = 1.0;//(m0/m1, m0>=m1)

CVector vPos10 = CVector(0.0, -radius0, 0.0) * massRatio;//1̏ʒu
CVector vPos00 = vPos10.reverse2() ;            //2̏ʒu
CVector vVel10 = CVector(speed0, 0.0, 0.0) ;    //1̏x(earth)
CVector vVel00 = vVel10.reverse2() * massRatio ;//0̏x(sun)

double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("SL_Twobody2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "../../shading.vert", "../../shadingS.frag");
	
  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
  glDeleteProgram(shaderProg);
	deleteDisplayLists();
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 150.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 80.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//萔
	e = 0.0;//0.5;
	muK = 0.5;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ
	elapseTime3 = 0.0;//ȉ~O̎p

	//eNX`[
  glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_0);
  setTexture(0);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_1);
  setTexture(1);
  
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[w]key:ܲ԰ڰ/دِ؂ւ \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[T]key:gbN[h؂ւ \n");
	printf("[S]key:Xg{\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
	printf("[F1]key:ȃ \n");
	printf("[F2]key:ڐx̑ \n");
	printf("[F3]key:ʔ̑ \n");
}

void initObject()
{
	flagStart = false;
	flagStrobo = false;
	countStrobo = 0;
	timeStrobo = 0.0;
	periodStrobo = 0.1;
	timeRate = 1.0;

	//̂̏ݒ
	numRigid0 = 2;
	numStrobo = 100;
	numRigid = numRigid0 + numStrobo;
	selNo = 0;
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	//rigid[0]:0(d)
	//rigid[1]:1(yj
	//2̂̏̕dS_ɂȂŃV~[g
	vPos10 = CVector(0.0, -radius0 , 0.0);//1̏ʒu
	vPos00 = vPos10.reverse2() * massRatio;//0̏ʒu
	vVel10 = CVector(speed0, 0.0, 0.0);//1̏x
	vVel00 = vVel10.reverse2() * massRatio;//0̏x

	//0(sun)
	rigid[0].mass = 100.0;
	rigid[0].vSize = CVector(4.0, 4.0, 4.0);
	rigid[0].vPos = vPos00;//CVector(0.0, 0.0, 0.0);
	rigid[0].vVelocity = vVel00;
	rigid[0].vOmega = CVector(0.0, sin(7.15 * pp), cos(7.15 * pp));//K
	rigid[0].vEuler = CVector(-7.15, 0.0, 0.0);
	rigid[0].q = getQFromEulerXYZ(rigid[0].vEuler) * rigid[0].q;
	rigid[0].ready();
	//1(earth)
	rigid[1].mass = 100.0 * massRatio;
	rigid[1].vSize = CVector(3.0, 3.0, 3.0);
	rigid[1].vPos = vPos10;
	rigid[1].vVelocity = vVel10;
	rigid[1].vOmega = CVector(0.0, M_PI * sin(23.4 * pp), M_PI * cos(23.4 * pp));//K
	rigid[1].vEuler = CVector(-23.4, 0.0, 0.0);
	rigid[1].q = getQFromEulerXYZ(rigid[1].vEuler) * rigid[1].q;
	rigid[1].ready();

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		if(((i - numRigid0) / 2) * 2 == i - numRigid0) 
		{
			rigid[i].color = CYAN;
			rigid[i].vSize = CVector(0.5, 0.5, 0.5);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
		else
		{
			rigid[i].color = YELLOW;
			rigid[i].vSize = CVector(0.5, 0.5, 0.5);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
	}
}

void setTexture(int n)
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
   //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[n]);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
  elapseTime2 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	//texture unit  texture object ̊֘At
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  //`
  // VF[_vO̓Kp 
	glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	GLint sunLoc = glGetUniformLocation(shaderProg, "sun");
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	//earth
	glUniform1i(selLoc, 1);
	glUniform1i(sunLoc, 0);
	rigid[1].select = true;
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	rigid[1].draw();
	//sun
	glUniform1i(sunLoc, 1);
	rigid[0].select = true;
  glUniform1i(imageLoc, 1);//GL_TEXTURE1Kp
	rigid[0].draw();

	glUniform1i(sunLoc, 0);
	if(flagStrobo)
	{
		for(int i = numRigid0; i < numRigid; i++)
		{
			glUniform1i(selLoc, 0);
			rigid[i].select = false;
			rigid[i].draw();
		}
	}

  glUseProgram(0);

	CVector massCenter;
	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
		float r2 = vDist2(rigid[1].vPos, rigid[0].vPos);//2拗
		float r = sqrt( r2 );
		if(r > (rigid[0].vSize.x + rigid[1].vSize.x) / 2.0 - 0.1)
		{
			rigid[0].vAccel = (rigid[0].vPos >> rigid[1].vPos) * GM * massRatio / r2;//sun
			rigid[1].vAccel = (rigid[1].vPos >> rigid[0].vPos) * GM / r2;
			rigid[0].attraction(dt * timeRate);
			rigid[1].attraction(dt * timeRate);
		}
		collision(dt * timeRate);

		massCenter = (rigid[0].vPos + massRatio * rigid[1].vPos) / (1.0 + massRatio);
		if(rigid[0].collision == 1)
		{ //Փˌ͐ڐGԂۂ悤ɂ
			if(r > (rigid[0].vSize.x + rigid[1].vSize.x) / 2.0 + 0.5)
			{
				rigid[0].vPos = (rigid[1].vPos >> rigid[0].vPos) * rigid[0].vSize.x/2.0 + massCenter;
				rigid[1].vPos = (rigid[0].vPos >> rigid[1].vPos) * rigid[0].vSize.x/2.0 + massCenter;
			}
		}
		
		if(flagOneStep) flagFreeze = true;
		
		if(flagStrobo)
		{
			if(countStrobo < numStrobo)
			{
				if( timeStrobo == 0.0) 
				{
					if((countStrobo/2) * 2 == countStrobo) rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
					else                 rigid[numRigid0 + countStrobo].vPos = rigid[0].vPos;
				}

				timeStrobo += dt;
				if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
				if(countStrobo >= numStrobo) countStrobo = 0;
			}
		}
	}

	if(flagFloor) glCallList(grid0);//iq

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("GM=%3.1f", GM, 180, 30);
		drawParam("radius0=%3.1f[m]", radius0, 300, 30);
		drawParam("speed0=%3.1f[m/s]", speed0, 440, 30);
		drawParam("massRatio=%2.3f", massRatio, 10, 60);
		drawParam("dist = %3.2f[m]", vDist(rigid[1].vPos, rigid[0].vPos), 400, 60);
	}
	if(flagTrack)//ɃR[fBOƕ\Ȃ
	{
		view.vCnt.x = massCenter.x;
		view.vCnt.y = massCenter.y;
		setCamera();
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
  case 'w':
	  if(flagWireframe == 1) flagWireframe = 0;
	  else flagWireframe = 1;
	  break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'T':
		flagTrack = !flagTrack;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{

	if(shiftMode == LIGHT)
	{
		//Î̕sړ
		float d = 5.0;
		switch( key )
		{
		case GLUT_KEY_RIGHT://y
			lightPos[1] += d;
			break;
		case GLUT_KEY_LEFT://-y
			lightPos[1] -= d;//
			break;
		case GLUT_KEY_UP:
			if(glutGetModifiers() == 0) lightPos[0] -= d;//-x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//z
			break;
		case GLUT_KEY_DOWN:
			if(glutGetModifiers() == 0) lightPos[0] += d;//x
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//-z
			break;
		default:
			break;
		}
	}

	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) GM += 100.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) GM -= 100.0;
	}

	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) radius0 += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) radius0 -= 1.0;
	}
	
	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) speed0 += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) speed0 -= 0.1;
	}
	if(key == GLUT_KEY_F4) 
	{
		if(massRatio < 0.01)
		{
			if(glutGetModifiers() == 0) massRatio += 0.001;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) massRatio -= 0.001;
			if(massRatio < 0.001) massRatio = 0.001;
		}
		else if(massRatio < 0.1)
		{
			if(glutGetModifiers() == 0) massRatio += 0.01;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) massRatio -= 0.01;
			if(massRatio < 0.01) massRatio = 0.01;
		}
		else//massRatio< 1.0
		{
			if(glutGetModifiers() == 0) massRatio += 0.1;
			if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) massRatio -= 0.1;
			if(massRatio > 1.0) massRatio = 1.0;
		}
	}
	initObject();


}

