/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ȉ~1
Sɑ傫Ȏʂ肵P͂̈͂󂯂D
Pǂ̈́EՓ˂lȂ
lvZGLSLgp
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../setupGP.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void initObject();
void setTextureVel();
void setTexturePos();
void setFramebufferVel();
void setFramebufferPos();
void drawNumberingPoints();
void rendering();
void renewVelocity(float dt);
void renewPosition(float dt);

//f[^̃TCY
int texWidth, texHeight;//͗p
int imgWidth, imgHeight;//particlẽeNX`
//͗pf[^z
float *velocity, *position;
//VF[_vO
GLuint program1, program2;
GLuint texID[2];//texture object
GLuint fb[2];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;
GLenum type = GL_FLOAT;

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

float GM = 10.0;
float RADIUS = 30.0;//͔aix-yʁj
float ratio = 0.5;//x-yʂ̔aɑ΂za̔j
float size = 2.0;
int numStar;//q()̌

double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("GP_EllipticalGalaxy1");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();//framebufferɕKv
  init();
	initGlsl(&program1, "simulation.vert", "velocity.frag");
	initGlsl(&program2, "simulation.vert", "position.frag");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
 	free(velocity);
	free(position);
	glDeleteLists(grid0, 1);
	glDeleteTextures(2, texID);
	glDeleteFramebuffersEXT(2, fb);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
	return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setCamera();//_߂
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 150.0;
	view.vCnt = CVector(0.0, 0.0, 0.0);
	view.theta = 0.0;
	view.phi = 0.0;
	setCamera();
	view.nearZ = 10.0;
	view.farZ = 1000.0;
	view0 = view;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);
 
	glGenTextures(2, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(2, fb);

	//\EBhEɕ_O鏀
	setFontBitmaps();
	//display list쐬
	createGrid();

	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
	printf("[F1]key:GMς̑ \n");
	printf("[F2]key:͔ȃ \n");
	printf("[F3]key:a䗦̑ \n");
}

void initObject()
{
  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ

	//particlȅl쐬
	texWidth  = 100;//25;//40;//WeNX`̉TCY
	texHeight = 100;//25;//40;//WeNX`̏cTCY
	numStar = texWidth * texHeight;//Š

	//ʔz̐錾
	velocity = (float*)malloc(4 * texWidth * texHeight * sizeof(float));
	position = (float*)malloc(4 * texWidth * texHeight * sizeof(float));

	//initialize of position,velocity and color;
	CVector vPos, vAxis, vTan;
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			int k = i + j * texWidth;
			float p = getRandom(0.0, 1.0);

			if(p < 0.6)
			{
				vPos = getRandomXYZ() * RADIUS;
			}
			else
				vPos = getRandomVector() * RADIUS * 1.2;
			
			vPos.z *= ratio * cos(M_PI * vPos.magnitudeXY2() / (2.0 * RADIUS)) ;
			position[k * 4 + 0] = vPos.x;
			position[k * 4 + 1] = vPos.y;
			position[k * 4 + 2] = vPos.z;
			position[k * 4 + 3] = getRandom(0.0, 20.0);//startTime;

			if(vPos.magnitudeXY() > RADIUS / 10.0) 
			{
				vAxis = CVector(0.0, 0.0, getRandom(-1.0, 1.0));
				vTan = vCross(vAxis, CVector(vPos.x, vPos.y, 0.0)).norm2();//ڐ
			}
			else
			{
				vAxis = CVector(getRandom(-1.0, 1.0), 0.0, 0.0);
				vTan = vCross(vAxis, CVector(0.0, vPos.y, vPos.z)).norm2();//ڐ
			}

			CVector vVel = vTan * (sqrt(GM));
			velocity[k * 4 + 0] = vVel.x;
			velocity[k * 4 + 1] = vVel.y;
			velocity[k * 4 + 2] = vVel.z;
		}

	setTextureVel();
	setTexturePos();
	setFramebufferVel();
	setFramebufferPos();
	flagStart = false;
	flagFreeze = false;
}

void setTextureVel()
{//͗p
  glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, velocity);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}
void setTexturePos()
{//͗p
  glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, position);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}

void setFramebufferVel()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setFramebufferPos()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

	timeStep = dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
		elapseTime2 += dt;

		//step1:x̍XV
		renewVelocity(timeStep);

		//step2:ʒu̍XV
		renewPosition(timeStep);

		if(flagOneStep) flagFreeze = true;
	}

	//Step3:q`
  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
  glLoadIdentity();
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//`惋[`
	rendering();

	if(flagCoord) 
	{
		drawWorldCoordinates(15.0);   //FԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("elapseTime2=%d[s]", (int)elapseTime2, 200, 30);
		drawParam("numStar=%d", numStar, 400, 30);
		drawParam("GM=%3.1f", GM, 20, 60);
		drawParam("RADIUS=%3.1f", RADIUS, 150, 60);
		drawParam("ratio=%3.1f", ratio, 320, 60);
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}

void renewVelocity(float dt)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
  //VF[_vOL
  glUseProgram(program1);
  GLint samplerVelLoc = glGetUniformLocation(program1, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program1, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint gmLoc = glGetUniformLocation(program1, "GM");
	glUniform1f(gmLoc, GM);
	GLint dtLoc = glGetUniformLocation(program1, "dt");
	glUniform1f(dtLoc, dt);
	GLint timeLoc = glGetUniformLocation(program1, "time");
	glUniform1f(timeLoc, elapseTime2);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, velocity);

	glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewPosition(float dt)
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
  //VF[_vOL
  glUseProgram(program2);
  GLint samplerVelLoc = glGetUniformLocation(program2, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program2, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint dtLoc = glGetUniformLocation(program2, "dt");
	glUniform1f(dtLoc, dt);
	GLint timeLoc = glGetUniformLocation(program2, "time");
	glUniform1f(timeLoc, elapseTime2);

	drawNumberingPoints();//l͗p̃eNX`iʁj\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, position);

  glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	//qԍʂ̊eZS_ɓ_`
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2qԍ
  glEnd();
}

void rendering()
{
  //`	
	glEnable(GL_POINT_SMOOTH);
	glColor3f(1.0, 1.0, 1.0);
	glPointSize(size);
	glDisable(GL_LIGHTING);
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			int k = i + j * texWidth;
			glVertex3f(position[4*k], position[4*k+1], position[4*k+2]);
		}
  glEnd();
	glPointSize(1.0);
	glDisable(GL_POINT_SMOOTH);
	if(flagFloor) glCallList(grid0);
	glEnable(GL_LIGHTING);
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) GM += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) GM -= 1.0;
		if(GM < 1.0) GM = 1.0;		
	initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) RADIUS += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) RADIUS -= 1.0;
		if(RADIUS < 10.0) GM = 10.0;
	initObject();
	}
	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) ratio += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) ratio -= 0.1;
		if(ratio < 0.3) ratio = 0.3;
	initObject();
	}
	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) size += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) size -= 1.0;
		if(size < 1.0) size = 1.0;
	}

}

