
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, velocity, normal;
	position = texture2DRect(samplerPos, texPos);		
	velocity = texture2DRect(samplerVel, texPos);

	//S̋
	float dist = length(position.xyz);

	if(dist > 0.5 && time >= position.w) position.xyz += velocity.xyz * dt;
	
	gl_FragColor = position;		
}
