/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2̋
͓m̑ݍp͂Ȃ
Pǂ̈́EՓ˂lȂ
lvZGLSLgp
point spritegp
͉]ύX
*/
//eNX`t@C
#define FILENAME_IN "../../bmp/particle.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../setupGP.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void initObject();
void setTextureVel();
void setTexturePos();
void setTextureCol();
void setTextureSprite();
void setFramebufferVel();
void setFramebufferPos();
void drawNumberingPoints();
void rendering();
void drawSprite();
void renewVelocity(float dt);
void renewPosition(float dt);

//f[^̃TCY
int texWidth, texHeight;//͗p
int imgWidth, imgHeight;//particlẽeNX`
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][4];
//͗pf[^z
float *velocity, *position, *color;
//VF[_vO
GLuint program1, program2, program3;
GLuint texID[4];//texture object
GLuint fb[2];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;
GLenum type = GL_FLOAT;

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

float GM = 10.0;
float diskRadius  = 20.0;//discaix-yʁj
float bulgeRadius = 5.0;//bulgeaix-yʁj
float ratio = 0.5;//bulgex-yʂ̔aɑ΂za̔j
float size = 10.0;//qTCY{
float angleY[] = {0.0, 90.0};//͂̒S̉]px
float angleZ[] = {0.0, 0.0 };
float pos0X[] = { 0.0, 0.0};//SW
float pos0Y[] = {-25.0, 25.0};
float pos0Z[] = {  0.0, 0.0};
int numStar;//qiǰ

double timeStep, timeStep0, timeStep1;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("GP_Galaxies1");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
	initGlsl(&program1, "simulation.vert", "velocity.frag");
	initGlsl(&program2, "simulation.vert", "position.frag");
	initGlsl(&program3, "rendering.vert");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
 	free(velocity);
	free(position);
	free(color);
	glDeleteLists(grid0, 1);
	glDeleteTextures(4, texID);
	glDeleteFramebuffersEXT(2, fb);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
	return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.12, 1.0);

  setCamera();//_߂
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 150.0;
	view.vCnt = CVector(0.0, 0.0, 0.0);
	view.theta = 90.0;
	view.phi = 0.0;
	setCamera();
	view.nearZ = 10.0;
	view.farZ = 1000.0;
	view0 = view;

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);
 
	glGenTextures(4, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(2, fb);

	//point sprite ̃eNX`[
	loadColorData32(image, &imgWidth, &imgHeight, FILENAME_IN);
  for(int j = 0; j < imgHeight; j++)
  {
		for(int i = 0; i < imgWidth; i++)
    {
			int n = i + j * imgHeight;
		  if( image[n][0] == 0 && image[n][1] == 0 &&  image[n][2] == 0) image[n][3] = 0; 
		  else image[n][3] = 255;
		}
	}
  setTextureSprite();

	//\EBhEɕ_O鏀
	setFontBitmaps();
	//display list쐬
	createGrid();

	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
	printf("[F1]key:GMς̑ \n");
	printf("[F2]key:diskȃ \n");
	printf("[F3]key:bulgeȃ \n");
	printf("[F4]key:a䗦̑ \n");
	printf("[F5]key:TCY̑ \n");
}

void initObject()
{
  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ

	//particlȅl쐬
	texWidth  = 200;//WeNX`̉TCY
	texHeight = 200;//WeNX`̏cTCY
	numStar = texWidth * texHeight;//Š

	//ʔz̐錾
	velocity = (float*)malloc(4 * texWidth * texHeight * sizeof(float));
	position = (float*)malloc(4 * texWidth * texHeight * sizeof(float));
	color = (float*)malloc(4 * texWidth * texHeight * sizeof(float));

	int i, j, k;
//------------------------------------------------------------------
	//No=0(Q)
	//͒Sʒu
	//#0i=0,j=0position[]
	k = 0;
	position[0] = pos0X[0];
	position[1] = pos0Y[0];
	position[2] = pos0Z[0];

	//initialize of position,velocity and color;
	CVector vPos, vVel, vAxis, vTan;
	for(int j = 0; j < texHeight/2; j++)
		for(int i = 0; i < texWidth; i++)
		{
			//ꂼ̋͂̒Sʒuo^Ă
			if(i == 0 && j == 0) continue;

			k = i + j * texWidth;

			float p = getRandom(0.0, 1.0);

			if(p < 0.8)//disc
			{
				vPos = getRandomVector() * diskRadius;
				if(vPos.magnitudeXY() > bulgeRadius) vPos.x *= getNormalRandom(0.0, 0.5);//yɖW
				vPos.z *= 0.05 * cos(M_PI * vPos.magnitudeXY2() / (2.0 * diskRadius)) ;
				if(vPos.magnitudeXY() > bulgeRadius && fabs(vPos.x) < 3.0 && fabs(vPos.z) < 1.0) color[k * 4 + 3] = 1.0;//rq̈
				else color[k * 4 + 3] = 0.0;//haloqȊOrȊÖ
			}
			else if(p < 0.9)//bulge
			{
				vPos = getRandomXYZ() * bulgeRadius;
				vPos.z *= ratio * cos(M_PI * vPos.magnitudeXY() / (2.0 * bulgeRadius)) ;
				color[k * 4 + 3] = 0.0;
			}
			else//halo1
			{
				vPos = getRandomVector() * diskRadius * 1.3;
				color[k * 4 + 3] = -1.0;
			}
			//F
			color[k * 4 + 0] = getRandom(0.1, 1.0);//red
			color[k * 4 + 1] = getRandom(0.1, 1.0);//green
			color[k * 4 + 2] = getRandom(0.1, 1.0);//blue
			if(fabs(vPos.z) < diskRadius * 0.05)//diskׂ̂Ăbulgëꕔ
				vAxis = CVector(0.0, 0.0, 1.0);
			else//halôׂĂbulgëꕔ
				vAxis = CVector(0.0, 0.0, getRandom(-0.2, 1.0));//ꕔ͔ΌɂȂ悤

			vTan = vCross(vAxis, vPos).norm2();//ڐ
			if(color[k*4+3] == 1.0) vVel = vTan * sqrt(GM/1000.0);//r
			else									  vVel = vTan * sqrt(GM);
			//W
			//͂̉]SύX
			vPos.rotX(angleY[0]);
			vPos.rotZ(angleZ[0]);
			position[k * 4 + 0] = vPos.x + pos0X[0];
			position[k * 4 + 1] = vPos.y + pos0Y[0];
			position[k * 4 + 2] = vPos.z + pos0Z[0];
			position[k * 4 + 3] = getRandom(0.0, 20.0);//startTime
			
			//x
			//͂̉]SύX
			vVel.rotY(angleY[0]);
			vVel.rotZ(angleZ[0]);
			velocity[k * 4 + 0] = vVel.x;
			velocity[k * 4 + 1] = vVel.y;
			velocity[k * 4 + 2] = vVel.z;
			velocity[k * 4 + 3] = getRandom(0.1, 1.0) ;//a			
		}
//------------------------------------------------------------------------------
	//No=1(_Q)
	//͒Sʒu
	i = 0; j = texHeight/2;
	k = i + j * texWidth;
	position[k * 4 + 0] = pos0X[1];
	position[k * 4 + 1] = pos0Y[1];
	position[k * 4 + 2] = pos0Z[1];
	//]
	vAxis = CVector(0.0, 0.0, 1.0);
	vAxis.rotY(angleY[1]);
	vAxis.rotZ(angleZ[1]);
//printf("ax=%f, ay=%f, az=%f \n", vAxis.x, vAxis.y, vAxis.z);
	color[k * 4 + 0] = vAxis.x;//
	color[k * 4 + 1] = vAxis.y;
	color[k * 4 + 2] = vAxis.z;

	//initialize of position,velocity and color;
	for(j = texHeight/2; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			//ꂼ̋͂̒Sʒuo^Ă
			if(i == 0 && j == texHeight/2) continue;

			k = i + j * texWidth;

			float p = getRandom(0.0, 1.0);

			if(p < 0.85)//disc
			{
				vPos = getRandomVector() * diskRadius;
				vPos.x *= getNormalRandom(0.0, 0.5);//yɖW
				vPos.z *= 0.05 * cos(M_PI * vPos.magnitudeXY2() / (2.0 * diskRadius)) ;
				if(vPos.magnitudeXY() > bulgeRadius && fabs(vPos.x) < 4.0 && fabs(vPos.z) < 1.0) color[k * 4 + 3] = 1.0;//rq̈
				else if(vPos.magnitudeXY() < bulgeRadius && fabs(vPos.x) < cos(M_PI * vPos.y / (2.0*bulgeRadius)) + 0.5 && fabs(vPos.z) < 1.0 ) color[k * 4 + 3] = 1.0;//r
				else color[k * 4 + 3] = 0.0;//haloqȊOrȊÖ
			}
			else if(p < 0.9)//bulge
			{
				vPos = getRandomXYZ() * bulgeRadius;
			  vPos.x *= getNormalRandom(0.0, 0.5);//yɖW
				vPos.z *= ratio * cos(M_PI * vPos.magnitudeXY() / (2.0 * bulgeRadius)) ;
				if(fabs(vPos.x) < cos(M_PI * vPos.y / (2.0*bulgeRadius)) + 0.5 && fabs(vPos.z) < 1.0 ) color[k * 4 + 3] = 1.0;//r
				else color[k * 4 + 3] = 0.0;
			}
			else//halo1
			{
				vPos = getRandomVector() * diskRadius * 1.3;
				color[k * 4 + 3] = -1.0;//haloq̈
			}

			//F
			color[k * 4 + 0] = getRandom(0.1, 1.0);//red
			color[k * 4 + 1] = getRandom(0.1, 1.0);//green
			color[k * 4 + 2] = getRandom(0.1, 1.0);//blue
			
			if(fabs(vPos.z) < diskRadius * 0.05)//diskׂ̂Ăbulgëꕔ
				vAxis = CVector(0.0, 0.0, 1.0);
			else//halôׂĂbulgëꕔ
				vAxis = CVector(0.0, 0.0, getRandom(-0.2, 1.0));//ꕔ͔ΌɂȂ悤

			vTan = vCross(vAxis, vPos).norm2();//ڐ
			if(color[k*4+3] == 1)	vVel = vTan * sqrt(GM/1000.0);//r
			else vVel = vTan * sqrt(GM);

			//W
			//͂̉]SύX
			vPos.rotX(angleY[1]);
			vPos.rotZ(angleZ[1]);
			position[k * 4 + 0] = vPos.x + pos0X[1];
			position[k * 4 + 1] = vPos.y + pos0Y[1];
			position[k * 4 + 2] = vPos.z + pos0Z[1];
			position[k * 4 + 3] = getRandom(0.0, 20.0);//startTime
			
			//x
			//͂̉]SύX
			vVel.rotY(angleY[1]);
			vVel.rotZ(angleZ[1]);
			velocity[k * 4 + 0] = vVel.x;
			velocity[k * 4 + 1] = vVel.y;
			velocity[k * 4 + 2] = vVel.z;
			velocity[k * 4 + 3] = getRandom(0.1, 1.0) ;//a			
		}

	setTextureVel();
	setTexturePos();
	setTextureCol();
	setFramebufferVel();
	setFramebufferPos();
	flagStart = false;
	flagFreeze = false;
}

void setTextureVel()
{//͗p
  glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, velocity);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}
void setTexturePos()
{//͗p
  glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, position);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}
void setTextureCol()
{//͗p
  glBindTexture(target, texID[3]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, color);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}

void setFramebufferVel()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setFramebufferPos()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureSprite()
{
  glBindTexture(GL_TEXTURE_2D, texID[2]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,imgWidth,imgHeight,0,GL_RGBA,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  //F̒i̐ݒj
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
  //Sprite
  glTexEnvi(GL_POINT_SPRITE, GL_COORD_REPLACE, GL_TRUE);
  
  // At@eXg̔ʊ֐ 
  glAlphaFunc(GL_GREATER, 0.5);

  //point sprite̻ނ
	glPointParameterf(GL_POINT_SIZE_MIN, 1.0);
	glPointParameterf(GL_POINT_SIZE_MAX, 100.0);
  float att[] = {0.0, 0.0, 0.001};
  glPointParameterfvEXT(GL_POINT_DISTANCE_ATTENUATION, att);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

	timeStep = dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
		elapseTime2 += dt;

		//step1:x̍XV
		renewVelocity(timeStep);

		//step2:ʒu̍XV
		renewPosition(timeStep);

		if(flagOneStep) flagFreeze = true;
	}

	//Step3:q`
  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
  glLoadIdentity();
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//`惋[`
	rendering();
	//XP[\
	glDisable(GL_LIGHTING);
	if(flagFloor) glCallList(grid0);
	glEnable(GL_LIGHTING);

	if(flagCoord) 
	{
		drawWorldCoordinates(15.0);   //FԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("elapseTime2=%d[s]", (int)elapseTime2, 200, 30);
		drawParam("numStar=%d", numStar, 400, 30);
		drawParam("GM=%3.1f", GM, 10, 60);
		drawParam("diskRadius=%3.1f", diskRadius, 100, 60);
		drawParam("bulgeRadius=%3.1f", bulgeRadius, 250, 60);
		drawParam("ratio=%3.1f", ratio, 410, 60);
		drawParam("size=%3.1f", size, 500, 60);
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}

void renewVelocity(float dt)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(target, texID[3]);//color
  //VF[_vOL
  glUseProgram(program1);
  GLint samplerVelLoc = glGetUniformLocation(program1, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program1, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
  GLint samplerColLoc = glGetUniformLocation(program1, "samplerCol");
  glUniform1i(samplerColLoc, 2);//GL_TEXTURE1Kp
  GLint widthLoc = glGetUniformLocation(program1, "texWidth");
  glUniform1i(widthLoc, texWidth);
  GLint heightLoc = glGetUniformLocation(program1, "texHeight");
  glUniform1i(heightLoc, texHeight);
	GLint gmLoc = glGetUniformLocation(program1, "GM");
	glUniform1f(gmLoc, GM);
	GLint bulgeLoc = glGetUniformLocation(program1, "bulgeRadius");
	glUniform1f(bulgeLoc, bulgeRadius);
	GLint dtLoc = glGetUniformLocation(program1, "dt");
	GLint timeLoc = glGetUniformLocation(program1, "time");
	glUniform1f(timeLoc, elapseTime2);
	glUniform1f(dtLoc, dt);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, velocity);

	glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewPosition(float dt)
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(target, texID[3]);//color
  //VF[_vOL
  glUseProgram(program2);
  GLint samplerVelLoc = glGetUniformLocation(program2, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program2, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
  GLint samplerColLoc = glGetUniformLocation(program2, "samplerCol");
  glUniform1i(samplerColLoc, 2);//GL_TEXTURE1Kp
  GLint widthLoc = glGetUniformLocation(program2, "texWidth");
  glUniform1i(widthLoc, texWidth);
  GLint heightLoc = glGetUniformLocation(program2, "texHeight");
  glUniform1i(heightLoc, texHeight);
	GLint dtLoc = glGetUniformLocation(program2, "dt");
	glUniform1f(dtLoc, dt);
	GLint timeLoc = glGetUniformLocation(program2, "time");
	glUniform1f(timeLoc, elapseTime2);

	drawNumberingPoints();//l͗p̃eNX`iʁj\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, position);

  glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	//qԍʂ̊eZS_ɓ_`
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2qԍ
  glEnd();
}

void rendering()
{
  //`	
	
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//xf[^
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//ʒuf[^
	//VF[_vOL
  glUseProgram(program3);
	GLint samplerVelLoc = glGetUniformLocation(program3, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
	GLint samplerPosLoc = glGetUniformLocation(program3, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint sizeLoc = glGetUniformLocation(program3, "size");
	glUniform1f(sizeLoc, size);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, texID[2]);

  glDisable(GL_DEPTH_TEST);
  glEnable(GL_BLEND);
  glBlendFunc(GL_ONE, GL_ONE);

  drawSprite();

  glDisable(GL_BLEND);
  glEnable(GL_DEPTH_TEST);

	glBindTexture(GL_TEXTURE_2D, 0);
	
  glUseProgram(0);
  glBindTexture(target, 0);
}

void drawSprite()
{
	glEnable(GL_VERTEX_PROGRAM_POINT_SIZE);//_ɂ闱qTCY̎ύX
  glEnable(GL_POINT_SPRITE);//|CgXvCgL
  glEnable(GL_TEXTURE_2D);  //eNX`}bsOL
  glEnable(GL_ALPHA_TEST);  //At@eXgL
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			int k = i + j * texWidth;
			glColor3f(color[4*k], color[4*k+1], color[4*k+2]);
			glVertex2f((float)i, (float)j);
		}
  glEnd();
  glDisable(GL_ALPHA_TEST);
  glDisable(GL_POINT_SPRITE);
  glDisable(GL_TEXTURE_2D);
	glDisable(GL_VERTEX_PROGRAM_POINT_SIZE);
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) GM += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) GM -= 1.0;
		if(GM < 1.0) GM = 1.0;		
		initObject();
	}
	if(key == GLUT_KEY_F2) 
	{
		if(glutGetModifiers() == 0) diskRadius += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) diskRadius -= 1.0;
		if(diskRadius < 10.0) diskRadius = 10.0;
		initObject();
	}
	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) bulgeRadius += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) bulgeRadius -= 1.0;
		if(bulgeRadius < 5.0) bulgeRadius = 5.0;
		initObject();
	}

	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) ratio += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) ratio -= 0.1;
		if(ratio < 0.1) ratio = 0.1;
		initObject();
	}
	if(key == GLUT_KEY_F5) 
	{
		if(glutGetModifiers() == 0) size += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) size -= 1.0;
		if(size < 1.0) size = 1.0;
	}

}

