
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCol;
uniform int texWidth, texHeight;
uniform float GM;
uniform float massRatio;
uniform float bulgeRadius;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, position0, position1, velocity, color;
	int i, j;
	float dist0, dist1;
	vec3 accel = vec3(0.0, 0.0, 0.0);//q()̉x
	vec3 accel0 = vec3(0.0, 0.0, 0.0);//͒S̉x
	vec3 accel1 = vec3(0.0, 0.0, 0.0);//͒S̉x
	
	position = texture2DRect(samplerPos, texPos);	
	velocity = texture2DRect(samplerVel, texPos);
	color = texture2DRect(samplerCol, texPos);
	
	position0 = texture2DRect(samplerPos, vec2(0.0, 0.0));//0̒Sʒu
	position1 = texture2DRect(samplerPos, vec2(0.0, float(texHeight/2)));//1̒Sʒu
	
	//͒S̋
	dist0 = length(position.xyz - position0.xyz);
	dist1 = length(position.xyz - position1.xyz);
	float d = length(position1.xyz - position0.xyz);
	
	//͒S̉x
	accel0 = normalize(position1.xyz - position0.xyz) * GM / (d);
	accel1 = -accel0 * massRatio;
	//͒S̑xXV
	if((texPos.x == 0.0 && texPos.y == 0.0)) velocity.xyz += accel0 * dt; 
	else if(texPos.x == 0.0 && texPos.y ==  float(texHeight/2)) velocity.xyz += accel1 * dt;
	else//qij̑xXV
	{
		accel.xyz = normalize(position0.xyz - position.xyz) * GM * massRatio / dist0;//ʂ̗q(0ɑ΂́j
		accel.xyz += normalize(position1.xyz - position.xyz) * GM / dist1;//ʂ̗qi1ɑ΂́j
		velocity.xyz += accel.xyz * dt;
	}
	
	gl_FragColor = velocity;
}
