/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

fn`V~[V
ׂĂ̘f͑z̈͂󂯂D
fǂ͋߂̂Ɉ͂^
Փ˂Ƃ
z͒SɌŒ
PointSprite𗘗pClvZɂGLSLgp
ԕɂ鍂
*/
#define FILENAME_IN "../../bmp/particle.bmp"


#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myMath4.h"
#include "../../myPrimitive4.h"
#include "../../myTexture4.h"
#include "../../bmpLoadSave.h"
#include "../../setupGP.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
//void setTexture(int n);
void initObject();
void setTextureVel();
void setTexturePos();
void setFramebufferVel();
void setFramebufferPos();
void setTextureSprite();
void setTextureCell();
void drawNumberingPoints();
void drawSprite();
void renewVelocity(float dt);
void renewPosition(float dt);
void clearTable();
void createTable();

//f[^̃TCY
int texWidth, texHeight;//͗p
int texCellX, texCellY;//Cellp
int imgWidth, imgHeight;//particlẽeNX`
float widthCell;//iqԊu

//particle
int numPoint;
//͗pf[^z
float *velocity, *position;
float *table;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][4];
//VF[_vO
GLuint program1, program2, program3;
float constMD;//->TCYϊW
GLuint texID[4];//texture object
GLuint fb[2];//frame buffer object 

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;
GLenum type = GL_FLOAT;

//oߎ
LARGE_INTEGER freq, lastTime, currentTime;
double pTime;
double elapseTime1, elapseTime2, elapseTime3;
//VF[_vO
GLuint shaderProg;

float GM = 10000.0;
float G_CONST = 0.001;//L͒萔
float MASS = GM / G_CONST;
//float distEffect = 15.0;
float	constMR = 0.06;//0.08;//->aϊ̔萔(̒l傫Ɛcf͏ȂȂj
int numPlanet;//cĂf

double timeStep, timeStep0, timeStep1;

float maxPosX[2], maxPosY[2], maxMass[2];//ʂ1Ԗڂ2Ԗ
int noK[2];

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(500, 100);
  //EBhE쐬
  glutCreateWindow("GP_PlanetaryCreation2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
	initGlsl(&program1, "simulation.vert", "velocity.frag");
	initGlsl(&program2, "simulation.vert", "position.frag");
	initGlsl(&program3, "rendering.vert");

  //Cxg[vɓ
  glutMainLoop();
  //\[X̉
 	free(velocity);
	free(position);
	free(table);
	glDeleteLists(grid0, 1);
	glDeleteTextures(4, texID);
	glDeleteFramebuffersEXT(2, fb);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
	glDeleteProgram(program3);
	return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.1, 0.1, 0.11, 1.0);

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
  view.dist= 500.0;
	view.vCnt = CVector(0.0, 0.0, 0.0);
	view.theta = 80.0;
	view.phi = 0.0;
	view.nearZ = 10.0;
	view.farZ = 2000.0;
	view0 = view;
	setCamera();

  //Ԋ֌W
  memset(&freq,  0x00, sizeof freq);
  memset(&lastTime, 0x00, sizeof lastTime);
  memset(&currentTime, 0x00, sizeof currentTime);
  QueryPerformanceCounter( &lastTime);
 
	glGenTextures(4, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(2, fb);

	//point sprite ̃eNX`[
	loadColorData32(image, &imgWidth, &imgHeight, FILENAME_IN);
  for(int j = 0; j < imgHeight; j++)
  {
		for(int i = 0; i < imgWidth; i++)
    {
			int n = i + j * imgHeight;
		  if( image[n][0] == 0 && image[n][1] == 0 &&  image[n][2] == 0) image[n][3] = 0; 
		  else image[n][3] = 255;
		}
	}
  setTextureSprite();

	//\EBhEɕ_O鏀
	setFontBitmaps();
	//display list쐬
	createGrid();//setupGP.h

	initObject();

	//L[̐
	printf("L[ɂʒu(l) \n");
	printf("@,Fy \n");
	printf("@,Fx \n");
	printf("@[Shift]{,Fz \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[R]key:JZbg \n");
	printf("[s]key:X^[g/Zbg \n");
	printf("[q]key:/ \n");
	printf("[1]key:1Xebv[V \n");
	printf("[p]key:p[^\/\؂ւ \n");
	printf("[c]key:W\/\؂ւ \n");
	printf("[F]key:iq\/\؂ւ \n");
	printf("[S]key:Xg{\؂ւ \n");
	printf("[F1]key:GMς̑ \n");
	printf("[F2]key:ʂ̏df\ \n");
}

void initObject()
{
	flagStrobo = false;
	countStrobo = 0;
	timeStrobo = 0.0;
	periodStrobo = 0.3;

  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0;//init()̑oߎ

	//
	minX = -400.0;
	maxX =  400.0;
	minY = -400.0;
	maxY =  400.0;
	widthCell = 10.0;//iqԊui1̃Z̕)
	texCellX = (int)((maxX - minX) / widthCell);//Z̉
	texCellY = (int)((maxY - minY) / widthCell);//Z̏c
	//particlȅl쐬
	texWidth  = 100;//WeNX`̉TCY
	texHeight = 100;//WeNX`̏cTCY
	numStrobo = texWidth;

	numPoint = texWidth * texHeight;//Sq
	numPlanet = numPoint - 1;//1͑z

	velocity = (float*)malloc(4 * texWidth * (texHeight + 1) * sizeof(float));//1sstrobopɎgp
	position = (float*)malloc(4 * texWidth * (texHeight + 1) * sizeof(float));
	table = (float*)malloc(4 * texCellX * texCellY * sizeof(float));

	//position and velocity;
	//sun
	position[0] = 0.0; position[1] = 0.0; position[2] = 0.0; position[3] = 0.0;
	velocity[0] = 0.0; velocity[1] = 0.0; velocity[2] = 0.0; velocity[3] = MASS;
	
	//planet
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			int k = i + j * texWidth;
			if(i == 0 && j == 0) continue; //sun
			CVector vPos = getRandomRingVectorXY(15.0, 380.0);
			position[k * 4 + 0] = vPos.x;
			position[k * 4 + 1] = vPos.y;
			position[k * 4 + 2] = 0.0;
			position[k * 4 + 3] = 0.0;
			CVector vTan = vCross(CVector(0.0, 0.0, 1.0), vPos).norm2();//ڐ
			float r = vPos.magnitudeXY();
			CVector vVel = vTan * (sqrt(GM / r));
			velocity[k * 4 + 0] = vVel.x;
			velocity[k * 4 + 1] = vVel.y;
			velocity[k * 4 + 2] = 0.0;
			velocity[k * 4 + 3] = getRandom(0.1, 1.0) * MASS / 1000.0;//
		}
	//strobo
	int j = texHeight;
	for(int i = 0; i < numStrobo; i++)
	{
		int k = i + j * texHeight;
		position[k * 4 + 0] = 10000.0;
		position[k * 4 + 1] = 10000.0;
		position[k * 4 + 2] = 0.0;
		position[k * 4 + 3] = 0.0;
		velocity[k * 4 + 0] = 0.0;
		velocity[k * 4 + 1] = 0.0;
		velocity[k * 4 + 2] = 0.0;
		velocity[k * 4 + 3] = 5.0 * MASS / 1000.0;//
	}

	createTable();

	setTextureVel();
	setTexturePos();
	setTextureCell();
	setFramebufferVel();
	setFramebufferPos();
	flagStart = false;
	flagFreeze = false;
}

void clearTable()
{
	for(int j = 0; j < texCellY; j++)
		for(int i = 0; i < texCellX; i++)
		{
			int cellNo = i + j * texCellX;
			int cellNo4 = cellNo * 4;//1̃Z4܂Ŋi[
			table[cellNo4 + 0] = -1000.0;
			table[cellNo4 + 1] = -1000.0;
			table[cellNo4 + 2] = -1000.0;
			table[cellNo4 + 3] = -1000.0;
		}
}

void createTable()
{
	float x, y;//qʒu
	int xCell, yCell;//ZԍW
	int objNo, cellNo, cellNo4;

	clearTable();
	numPlanet = 0;

	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			//̗q̗qio[
			objNo = i + j * texWidth;
			if(velocity[4*objNo+3] == 0.0) continue;//łq(0͏ŗq)
			if(objNo != 0) {numPlanet ++;}//cĂfq(objNo=0͑zj

			//qio[objNöʒuW
			x = position[4 * objNo];
			y = position[4 * objNo + 1];
	
			//̗q݂Zʒuԍ
			xCell = (int)((x - minX) / widthCell);
			yCell = (int)((y - minY) / widthCell);
			//̃Zԍ
			cellNo = xCell + yCell * texCellX;
			if(xCell < 0 || xCell >= texCellX) continue; //̈O
			if(yCell < 0 || yCell >= texCellY) continue; //̈O
			cellNo4 = 4 * cellNo;
			if(table[cellNo4] < 0.0) table[cellNo4] = (float)objNo; 
			else if(table[cellNo4+1] < 0.0) table[cellNo4+1] = (float)objNo;
			else if(table[cellNo4+2] < 0.0) table[cellNo4+2] = (float)objNo;
			else if(table[cellNo4+3] < 0.0) table[cellNo4+3] = (float)objNo;
			else
			{
				//Z5ȏ㑶݂Ƃtable[4*cellNo]̃IuWFNgɋzC̃IuWFNg
				//(table[4*cellNo]ɓĂ闱qԍ̎ʂɒǉj
				velocity[4*(int)table[cellNo4] + 3] += velocity[4*objNo + 3];
				//ŃtO
				velocity[4*objNo+3] = 0.0;
			}
		}
		setTextureVel();
		setTextureCell();
}

void setTextureVel()
{//͗p
  glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight+1, 0, format, type, velocity);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}
void setTexturePos()
{//͗p
  glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight+1, 0, format, type, position);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}

void setFramebufferVel()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setFramebufferPos()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureSprite()
{
  glBindTexture(GL_TEXTURE_2D, texID[2]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,imgWidth,imgHeight,0,GL_RGBA,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  //F̒i̐ݒj
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
  //Sprite
  glTexEnvi(GL_POINT_SPRITE, GL_COORD_REPLACE, GL_TRUE);
  
  // At@eXg̔ʊ֐ 
  glAlphaFunc(GL_GREATER, 0.5);

  //point sprite̻ނ
	glPointParameterf(GL_POINT_SIZE_MIN, 1.0);
	glPointParameterf(GL_POINT_SIZE_MAX, 1000.0);
  float atten[] = {0.0, 0.0, 0.001};
//  float atten[] = {0.0, 0.1, 0.0};
  glPointParameterfvEXT(GL_POINT_DISTANCE_ATTENUATION, atten);
}

void setTextureCell()
{
  glBindTexture(target, texID[3]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
//  glTexImage2D(target, 0, internalFormat, texCellX, texCellY, 0, format, GL_INT, table);
  glTexImage2D(target, 0, internalFormat, texCellX, texCellY, 0, format, type, table);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;

if((int)elapseTime2 == 0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 10.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 20.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 30.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 50.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 70.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 100.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 150.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 200.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 300.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 500.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 700.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 1000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 2000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 3000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 5000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//1.39
if((int)elapseTime2 == 10000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//2.78
if((int)elapseTime2 == 20000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);
if((int)elapseTime2 == 50000.0) printf("elapseTime2 = %d  numPlanet = %d \n", (int)elapseTime2, numPlanet);//13.89
  }
  QueryPerformanceCounter( &lastTime);

	timeStep = dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 10.0 * timeStep0 || timeStep < timeStep0 / 10.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart == true && flagFreeze == false && flagFreeze0 == false) 
	{
		elapseTime2 += dt;

		//step1:Ze[u̍쐬
		createTable();

		//step2:x̍XV
		renewVelocity(timeStep);

		//step3:ʒu̍XV
		renewPosition(timeStep);

		if(flagOneStep) flagFreeze = true;

		//Strobo
		if(countStrobo < numStrobo)
		{

			if( timeStrobo == 0.0) 
			{
					int k = countStrobo + texHeight * texHeight;
					if((countStrobo/2) * 2 == countStrobo) 
					{
						position[k * 4 + 0] = position[4*noK[0]];
						position[k * 4 + 1] = position[4*noK[0]+1];
					}
					else    
					{
						position[k * 4 + 0] = position[4*noK[1]];
						position[k * 4 + 1] = position[4*noK[1]+1];
					}
			}

			timeStrobo += dt;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
			
			setTexturePos();//position[]zύX̂ŕKv
		}

	}

	//Step3:rendering.vertœ_`
  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //`	
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//xf[^
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//ʒuf[^
  glUseProgram(program3);
	GLint samplerVelLoc = glGetUniformLocation(program3, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
	GLint samplerPosLoc = glGetUniformLocation(program3, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, texID[2]);
	drawSprite();
  
	glBindTexture(GL_TEXTURE_2D, 0);
	
  glUseProgram(0);

  glBindTexture(target, 0);

	glDisable(GL_LIGHTING);
	if(flagFloor) glCallList(grid0);//FԍW
	glEnable(GL_LIGHTING);

	if(flagCoord) 
	{
		drawWorldCoordinates(30.0);//W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("elapseTime2=%d[s]", (int)elapseTime2, 200, 30);
		drawParam("numPlanet=%d", numPlanet, 400, 30);
		drawParam("GM=%3.1f", GM, 20, 60);
	}

	//obt@̐؂ւ
  glutSwapBuffers();
}

void renewVelocity(float dt)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(target, texID[3]);//cell

  glUseProgram(program1);
  GLint samplerVelLoc = glGetUniformLocation(program1, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program1, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
  GLint samplerCellLoc = glGetUniformLocation(program1, "samplerCell");
  glUniform1i(samplerCellLoc,2);//GL_TEXTURE2Kp
	GLint widthLoc = glGetUniformLocation(program1, "texWidth");
	glUniform1i(widthLoc, texWidth);
	GLint heightLoc = glGetUniformLocation(program1, "texHeight");
	glUniform1i(heightLoc, texHeight);
	GLint gridLoc = glGetUniformLocation(program1, "widthCell");
	glUniform1f(gridLoc, widthCell);
	GLint minXLoc = glGetUniformLocation(program1, "minX");
	glUniform1f(minXLoc, minX);
	GLint maxXLoc = glGetUniformLocation(program1, "maxX");
	glUniform1f(maxXLoc, maxX);
	GLint minYLoc = glGetUniformLocation(program1, "minY");
	glUniform1f(minYLoc, minY);
	GLint maxYLoc = glGetUniformLocation(program1, "maxY");
	glUniform1f(maxYLoc, maxY);

	GLint gravityLoc = glGetUniformLocation(program1, "G_CONST");
	glUniform1f(gravityLoc, G_CONST);
	GLint constLoc = glGetUniformLocation(program1, "constMR");
	glUniform1f(constLoc, constMR);
	GLint dtLoc = glGetUniformLocation(program1, "dt");
	glUniform1f(dtLoc, dt);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, velocity);
	glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewPosition(float dt)
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[1] );
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(target, texID[0]);//velocity
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(target, texID[1]);//position
  glUseProgram(program2);
  GLint samplerVelLoc = glGetUniformLocation(program2, "samplerVel");
  glUniform1i(samplerVelLoc, 0);//GL_TEXTURE0Kp
  GLint samplerPosLoc = glGetUniformLocation(program2, "samplerPos");
  glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint dtLoc = glGetUniformLocation(program2, "dt");
	glUniform1f(dtLoc, dt);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

  // VF[_vỎ 
  glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, position);

  glBindTexture(target, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}


void drawNumberingPoints()
{
	//r[|[g̑傫𗱎qԍʂ̑傫ɐݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\tIuWFNgiqԍʁj
	
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_Wqԍ
  glEnd();

}

void drawSprite()
{
	glDisable(GL_LIGHTING);
	glEnable(GL_VERTEX_PROGRAM_POINT_SIZE);//TCYωL
  glEnable(GL_POINT_SPRITE);//|CgXvCgL
  glEnable(GL_TEXTURE_2D);  //eNX`}bsOL
  glEnable(GL_ALPHA_TEST);  //At@eXgL
  
  glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
		{
			if(i == 0 && j == 0) glColor3f(1.0, 0.0, 0.0);//sun
			else                 glColor3f(0.0, 1.0, 1.0);//planet
			glVertex2f((float)i, (float)j);
		}
	
	if(flagStrobo)
	{
		int j = texHeight;
		for(int i = 0; i < numStrobo; i++)
		{
			if(i == 2 * (i / 2)) glColor3f(1.0, 1.0, 0.0);
			else glColor3f(1.0, 0.0, 1.0);
			glVertex2f((float)i, (float)j);
		}
	}

  glEnd();
  glDisable(GL_ALPHA_TEST);
  glDisable(GL_POINT_SPRITE);
  glDisable(GL_TEXTURE_2D);
	glDisable(GL_VERTEX_PROGRAM_POINT_SIZE);
	glEnable(GL_LIGHTING);
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://camera reset
	  view = view0;
	  setCamera();
	  break;
  case 's':
		flagStart = !flagStart;
		if(!flagStart) initObject();
		if(flagStart) elapseTime2 = 0.0;
		break;
	case 'q':
		flagFreeze = !flagFreeze;
		if(!flagFreeze) flagOneStep = false;
		break;
	case '1'://one step motion
		flagOneStep = true;
		flagFreeze = false;
		break;
	case 'p':
		flagParamShow = !flagParamShow;
		break;
	case 'c':
		flagCoord = !flagCoord;
		break;
	case 'F':
		flagFloor = !flagFloor;
		break;
	case 'S':
		flagStrobo = !flagStrobo;
		break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	//Function key
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) GM += 100.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) GM -= 100.0;
		if(GM < 100) GM = 100.0;
		
		initObject();
	}

	maxMass[0] = 0.0;
	maxMass[1] = 0.0;
	if(key == GLUT_KEY_F2)
	{
		flagFreeze = true;
		for(int k = 1; k < numPoint;k++)
		{
			if(velocity[4*k+3] == 0.0) continue;
			if(velocity[4*k+3] > maxMass[0]) 
			{
				maxPosX[0] = position[4*k];
				maxPosY[0] = position[4*k+1];
				maxMass[0] = velocity[4*k+3];
				noK[0] = k;
			}
		}
		for(int k = 1; k < numPoint;k++)
		{
			if(velocity[4*k+3] == 0.0) continue;
			if(velocity[4*k+3] > maxMass[1] && velocity[4*k+3] < maxMass[0]) 
			{
				maxPosX[1] = position[4*k]; 
				maxPosY[1] = position[4*k+1];
				maxMass[1] = velocity[4*k+3];
				noK[1] = k;
			}
		}
		printf("noK1=%d  x=%f, y=%f \n", noK[0], maxPosX[0], maxPosY[0]);
		printf("noK2=%d  x=%f, y=%f \n", noK[1], maxPosX[1], maxPosY[1]);
		printf("mass1=%f, mass2=%f \n", maxMass[0], maxMass[1]);
		flagFreeze = false;
	}
}

