
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCol;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, velocity, color;
	position = texture2DRect(samplerPos, texPos);		
	velocity = texture2DRect(samplerVel, texPos);
	color = texture2DRect(samplerCol, texPos);

	//S̋
	float dist = length(position.xyz);

	if(dist > 0.5)//S͌Œ
	{
		if(color.a == -1.0) //halö͎ԍ
		{ 
		  if(time >= position.w) 
		    position.xyz += velocity.xyz * dt;
		}
		else position.xyz += velocity.xyz * dt;
	}

	gl_FragColor = position;		
}
