//parameters.h
//萔,tO
float g = 9.8;//d͉x
float e = 0.5;//W
float viscous = 0.1;//SRW
float buoyant = 1.0;//1kg̍̂ɑ΂镂
float cSpring = 200.0;//pp
float muK = 0.5;//CW

//Փˊ֘Ãp[^
float spaceCoord = 2.0;//Wlr̊Ԋu
bool flagCollision = true;//Փ˗L/tO
enum AwakeMode { ONLY, WHOLE };//o[h
AwakeMode awakeMode = ONLY;

enum ShiftMode {TRANSLATE, ROTATION, LIGHT, VELOCITY};
ShiftMode shiftMode = TRANSLATE;
enum CoordMode { INERTIAL, OBJECT};
CoordMode coordMode = INERTIAL;

//̑
//]^
float speedRotation = 0.0;
float central = 0.1;//S͌W
//flag
bool flagColor = false;//Փˎ̐FύXtO

//^̈
float spaceX = 100.0;
float spaceY = 100.0;

float floorMinX = -50.0;
float floorMaxX =  50.0;
float floorMinY = -50.0;
float floorMaxY =  50.0;
//IIuWFNgԍ
int selNo = 0;

enum Kind {SPHERE, CUBE, BOX, CYLINDER, COLUMN};
enum Color {RED, GREEN, BLUE, YELLOW, CYAN, MAGENTA, WHITE, GRAY};

float red[] = {0.8, 0.1, 0.1, 1.0};
float green[] = {0.1, 0.8, 0.1, 1.0};
float blue[] = {0.1, 0.1, 0.8, 1.0};
float yellow[] = {0.8, 0.8, 0.1, 1.0};
float cyan[] = {0.1, 0.8, 0.8, 1.0};
float magenta[] = {0.8, 0.1, 0.8};
float white[] = {0.8, 0.8, 0.8, 1.0};
float gray[] = {0.5, 0.5, 0.5, 1.0};

//display list
int sphere, cube, box, cylinder, column, torus, cone, pyramid, floor0, grid0;
int sphereTex, cubeTex, boxTex, cylinderTex, columnTex, torusTex, coneTex, pyramidTex;

void createSphere()
{
	sphere = glGenLists(1);
	if(sphere == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(sphere, GL_COMPILE);
	drawSphere(0.5, 10, 10);
	glEndList();
}

void createCube()
{
	cube = glGenLists(1);
	if(cube == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cube, GL_COMPILE);
	drawCube(1.0);
	glEndList();
}
//pɊۂ݂̂钼(Փ˔莞CUBEƂȂf[^\j
float boxEps1 = 0.1;
float boxEps2 = 0.1;
void createBox()
{
	box = glGenLists(1);
	if(box == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(box, GL_COMPILE);
	drawSuper(0.5, 10, 10, boxEps1, boxEps2);
	glEndList();
}

void createCylinder()
{
	cylinder = glGenLists(1);
	if(cylinder == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(cylinder, GL_COMPILE);
	drawCylinder(0.5, 0.5, 1.0, 12, 4);
	glEndList();
}
//pɊۂ݂̂~
float columnEps1 = 0.1;//0.5;
float columnEps2 = 1.0;//0.5;//1.0;
void createColumn()
{
	column = glGenLists(1);
	if(column == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(column, GL_COMPILE);
	drawSuper(0.5, 10, 10, columnEps1, columnEps2);
	glEndList();
}
void createFloor()
{
	floor0 = glGenLists(1);
	if(floor0 == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(floor0, GL_COMPILE);
	drawFloorZ(floorMaxX - floorMinX, floorMaxY - floorMinY, 10, 10);
	glEndList();
}

void createGrid()
{
	grid0 = glGenLists(1);
	if(grid0 == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(grid0, GL_COMPILE);
	drawGridZ(floorMaxX - floorMinX, floorMaxY - floorMinY, 10, 10);
	glEndList();
}

void createDisplayLists()
{
	createSphere();
	createCube();
	createCylinder();
	createBox();
	createColumn();
	createFloor();
	createGrid();
}
void deleteDisplayLists()
{
	glDeleteLists(sphere, 1);
	glDeleteLists(cube, 1);
	glDeleteLists(cylinder, 1);
	glDeleteLists(box, 1);
	glDeleteLists(column, 1);
	glDeleteLists(floor0, 1);
	glDeleteLists(grid0, 1);
}
//-----------------------------------------------------------------
//
float lightPos[]  = {10.0, 10.0, 80.0, 1.0};//ʒu
float lightPos0[] = {10.0, 10.0, 80.0, 1.0};//ʒu(l)
void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {0.7, 0.7, 0.7, 1.0}; //gU
  float lightSpecular0[] = {0.5, 0.5, 0.5, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}




